/* ix/MBox (bled.c) by Volker Schuermann, 04.12.1993

   This C source code contains the following functions:
  
   melt()             Haven't a clue!
   bledmove()         Haven't a clue!
   zeigen()           Haven't a clue!
   bl_loesch()        Haven't a clue!
   upload()           Haven't a clue!
   korrigieren()      Haven't a clue!
   crunch()           Haven't a clue!
   befehl()           Haven't a clue!
   erfassen()         Haven't a clue!
   bl_sigcatch()      Haven't a clue!
   getfile()          Haven't a clue!
   main()             Haven't a clue!

   Contact <volkers@unnet.wupper.de> for help! */





#include <stdio.h>
#include <setjmp.h>
#include <signal.h>

#define VERSION "LED 3.6pl3 (SVR4)"
#define AUTOR   "Volker.Schuermann@unnet.wupper.de"

#ifndef STRING
#define STRING 85
#endif

#ifndef LONGSTRING
#define LONGSTRING 256
#endif


#ifndef _MINIX
#define UNSIGNED unsigned
#else
#define UNSIGNED
#endif

#include "proto.h"
#include "deutsch.msg"
extern unsigned char HOME[STRING];


#define CR     13
#define LF     10
#define BS      8
#define CTRL_X 24
#define CTRL_D  4
#define CTRL_E	5


#define TMP "/tmp"

#define APPEND 1
#define INSERT 2
#define FINISH 3
#define QUIT   4
#define UPLOAD 5

#ifdef _MBOX
#undef _MBOX
#endif

static int melted;

static UNSIGNED char tmp1[STRING];
static UNSIGNED char tmp2[STRING];

static int von, bis;
static int max_line;

static UNSIGNED char imode;

static UNSIGNED char THE_FILE[STRING];
static int  THE_LINE;
UNSIGNED char headinfo[STRING];



int UMLAUT;
extern int USER_language;

int melt(startlin)
int startlin;
{
  FILE *fp;
  FILE *ff;
  FILE *fg;
  UNSIGNED char s[LONGSTRING];
  UNSIGNED char tmp3[STRING];
  int i;


  if (melted == 0) return 0;

  sprintf(tmp3, "%s/bled3.%d", TMP, getpid());

  fg = fopen(tmp3, "w");
  if (fg == NULL) {
	printf("\n%s\n", tmp3);
	exit(-1);
  }
  fp = fopen(tmp1, "r");
  if (fp == NULL) {
	printf("\n%s\n", tmp1);
	exit(-1);
  }
  i = 0;
  while ((i < startlin) && (fgets(s, LONGSTRING, fp) != NULL)) {
	fputs(s, fg);
	i++;
  }
  ff = fopen(tmp2, "r");
  if (ff != NULL) {
	while (fgets(s, LONGSTRING, ff) != NULL) {
		fputs(s, fg);
		i++;
	}
	fclose(ff);
  }
  while (fgets(s, LONGSTRING, fp) != NULL) {
	fputs(s, fg);
  }
  fclose(fg);
  fclose(fp);

  unlink(tmp1);
  mbrename(tmp3, tmp1);
  unlink(tmp3);

  return 0;
}



bledmove(from, to)
UNSIGNED char from[], to[];
{
  FILE *fp;
  FILE *ff;
  UNSIGNED char s[LONGSTRING];


  fp = fopen(from, "r");
  if (fp == NULL) {
	printf("\n%s\n", from);
	exit(-1);
  }
  ff = fopen(to, "w");
  if (ff == NULL) {
	printf("\n%s\n", from);
	exit(-1);
  }
  while (fgets(s, LONGSTRING, fp) != NULL) {
	fputs(s, ff);
  }
  fclose(fp);
  fclose(ff);
}





zeigen(mode)
UNSIGNED char mode;
{
  FILE *fp;
  UNSIGNED char s[LONGSTRING];
  int i;

  if ((von != 0) && (bis == 0)) bis = von;
  if ((von == 0) && (bis == 0)) bis = 32000;

  if (von > bis) {
	printf("\n\nLED: %s\n", GetText("BLD01_MSG"));
	return;
  }
  fp = fopen(tmp1, "r");
  if (fp == NULL) {
	printf("\n%s\n", tmp1);
	exit(-1);
  }
  i = 1;
  printf("\n\n");
  while (fgets(s, LONGSTRING, fp) != NULL) {
	if ((i >= von) && (i <= bis)) {
		if (mode == 'l')
			printf("L %04.4d %s", i, s);
		else
			printf("%s", s);
	}
	i++;
  }
  fclose(fp);
}



bl_loeschen()
{
  FILE *fp;
  FILE *ff;
  UNSIGNED char s[LONGSTRING];
  int i;

  if ((von != 0) && (bis == 0)) bis = von;
  if ((von == 0) && (bis == 0)) bis = 32000;

  if (von > bis) {
	printf("\n\nLED: %s\n", GetText("BLD01_MSG"));
	return;
  }
  ff = fopen(tmp2, "w");
  if (ff == NULL) {
	printf("\n%s\n", tmp2);
	exit(-1);
  }
  fp = fopen(tmp1, "r");
  if (fp == NULL) {
	printf("\n%s\n", tmp1);
	exit(-1);
  }
  i = 1;
  printf("\n\n");
  while (fgets(s, LONGSTRING, fp) != 0) {
	if ((i < von) || (i > bis)) {
		fputs(s, ff);
	}
	i++;
  }
  fclose(fp);
  fclose(ff);

  unlink(tmp1);
  mbrename(tmp2, tmp1);
}



upload()
{
  FILE *fp;
  UNSIGNED char c;
  UNSIGNED char lf;

  fp = fopen(tmp2, "w");
  if (fp == NULL) {
	printf("\n%s\n", tmp2);
	exit(-1);
  }
  printf("\n\nLED: %s\n\n", GetText("BLD02_MSG"));

  c = 0;
  lf = CR;


  while ((c != CTRL_E) && (c != CTRL_D)) {

        c = getint();

	if ((c == CR) && (lf == CR)) fputc(LF, fp);
	if (c == CR) lf = CR;
	if (c == LF) lf = LF;
	if ((c != CTRL_E) && (c != CTRL_D) && (c != CR)) {
		fputc(c, fp);
	}
  }
  fclose(fp);
}



korrigieren()
{
  FILE *fp;
  FILE *ff;
  UNSIGNED char s[LONGSTRING];
  UNSIGNED char t[LONGSTRING];
  int i, z;

  if (von == 0) {
	printf("\n\nLED: %s\n", GetText("BLD01_MSG"));
	return;
  }
  fp = fopen(tmp1, "r");
  if (fp == NULL) {
	printf("\n%s\n", tmp1);
	exit(-1);
  }
  ff = fopen(tmp2, "w");
  if (ff == NULL) {
	printf("\n%s\n", tmp1);
	exit(-1);
  }
  i = 1;
  while (fgets(s, LONGSTRING, fp) != NULL) {
	if (i == von) {
		t[0] = '\0';
		strcpy(t, s); 
		z = strlen(t);
		while(t[z] < 33) z--;
		z++;
		t[z] = '\0';
		s[0] = '\0';
		if (strlen(t) < 74)
			printf("\n\nK %04.4d ", i);
		else
			printf("\n\n");
		strcat(s, getline(74, 1001, ' ', t));
		strcat(s, "\n");
		printf("\n");
	}
	fputs(s, ff);
	i++;
  }
  fclose(ff);
  fclose(fp);
  unlink(tmp1);
  mbrename(tmp2, tmp1);
}




crunch(s)
UNSIGNED char s[];
{
  UNSIGNED char t[STRING];
  int i = 0, a = 0;

  von = 0;
  bis = 0;

  while (s[i] != '\0') {
	if ((s[i] == ',') || (s[i] == '-')) a = i;
	i++;
  }
  if (a == 0) a = i;
  t[0] = '\0';
  strcat(t, strcopy(s, 3, (a - 1)));
  von = atoi(t);
  t[0] = '\0';
  strcat(t, strcopy(s, (a + 1), i));
  bis = atoi(t);
  if ((a != i) && (bis == 0)) bis = 32000;
}





int befehl(s)
UNSIGNED char s[];
{
  UNSIGNED char c = s[1];

  if ((s[2] != ' ') && (s[2] != '\0') && (s[1] != '\0')) {
	printf("\n\nLED: %s\n", GetText("BLD03_MSG"));
	return 0;
  }
  crunch(s);

  switch (c) {
      case '\0':
			return FINISH;
			break;
      case '?':
			printf("\n\n%c", CR);
			ansi("mr");
			printf(" %s  -  %s ", VERSION, BLD04_MSG);
			ansi("me");
			printf("\n\n");
			printf("%s\n", GetText("BLD05_MSG"));
			printf("%s\n", GetText("BLD06_MSG"));
			printf("%s\n", GetText("BLD07_MSG"));
			printf("%s\n", GetText("BLD08_MSG"));
			printf("%s\n", GetText("BLD09_MSG"));
			printf("%s\n", GetText("BLD10_MSG"));			
			printf("%s\n", GetText("BLD11_MSG"));
			printf("%s\n", GetText("BLD12_MSG"));
			printf("%s\n", GetText("BLD13_MSG"));
			printf("%s\n", GetText("BLD14_MSG"));
			printf("\n");
			printf("%s\n", GetText("BLD15_MSG"));
			printf("%s\n", GetText("BLD16_MSG"));
			printf("%s\n", GetText("BLD17_MSG"));
			break;
			
      case 'h':	        printf("\n\n%c", CR);
			ansi("mr");
			printf(" %s  -  %s ", VERSION, BLD18_MSG);
			ansi("me");
			printf("\n\n");
			sprintf(s,"more %s/etc/languages/bled/deutsch",HOME);
			system( s );
			break;			
      case 'a':	
			return APPEND;	
			break;
      case 'i':
			return INSERT;	
			break;
      case 'l':
      case 'L':
			zeigen(c);
			return APPEND;
			break;
      case 'd':
			bl_loeschen();
			return APPEND;
			break;
      case 'k':
      case 'c':
			korrigieren();
			return APPEND;
      case 'u':
			upload();
			return UPLOAD;
      case 'Q':
			unlink(tmp1);
			unlink(tmp2);
			printf("\n\nLED: %s\n\n", GetText("BLD19_MSG"));
			exit(0);
			break;
      default:		printf("\n\nLED: %s\n", GetText("BLD20_MSG"));
}
  return 0;
}





int erfassen(line, mode)
int line, mode;
{
  FILE *fp;
  UNSIGNED char s[STRING];
  UNSIGNED char def[STRING];
  int ok = 0;
  int elin = line;
  int startlin = line - 1;
  int a, b;

  melted = 1;			/* Sicher ist sicher ... */
  THE_LINE = startlin;

  fp = fopen(tmp2, "w");
  if (fp == NULL) return -1;

  def[0] = '\0';

  do {
	if (elin > max_line) max_line = elin;
	printf("\n%c %04.4d ", imode, elin);
	s[0] = '\0';
	if (def[0] == '\0')
		strcat(s, getline(73, 1, ' ', " "));
	else
		strcat(s, getline(73, 1001, ' ', def));

	if (strcomp("<BREAK>", s) == 0) {
		sprintf(s, ".?");
	}
	if (strcomp("\".?\"", s) == 0) {
		sprintf(s, ".?");
	}
	if (s[0] == '\0') {
		printf("\n\n(%s: \".?\")\n", GetText("BLD04_MSG"));
  	}
	if (s[0] == '.') {
		fclose(fp);
		melted = melt(startlin);

		ok = befehl(s);

		if (ok == UPLOAD) {
			melted = 1;
			melted = melt(startlin);
			ok = APPEND;
		}
		if (ok == INSERT) {
			imode = 'I';
			if (von < 1) von = 1;
			if (von > max_line) {
				ok = APPEND;
			}
			 else {
				startlin = von - 1;
				THE_LINE = startlin;
				elin = von;
			}
		}
		if (ok == APPEND) {
			imode = 'A';
			unlink(tmp2);
			mbrename(tmp1, tmp2);
			startlin = getfile(tmp2);
			if (startlin < 1) startlin = 0;
			elin = startlin + 1;
			THE_LINE = startlin;
		}
		fp = fopen(tmp2, "w");
		if (fp == NULL) return -1;

	} else {
		def[0] = '\0';
		a = strlen(s);
		if (a == 73) {
			while ((s[a] != ' ') && (a > 40)) a--;
			if (s[a] == ' ') {
				strcat(def, strcopy(s, (a + 1), 73));
				s[a] = '\0';
				for (b = a; b < 73; b++) printf("%c", BS);
				for (b = a; b < 73; b++) printf(" ");
			}
		}
		fprintf(fp, "%s\n", s);
		elin++;
		melted++;
	}
  } while (ok != FINISH);
  return elin;
}



bl_sigcatch(sig)
int sig;
{

  switch (sig) {
      case SIGINT:
      case SIGQUIT:
#ifdef _UNNET
      case SIGHUP:
#endif
      case SIGABRT:
      case SIGTERM:
	melted++;
	melt(THE_LINE);
	bledmove(tmp1, THE_FILE);
	unlink(tmp1);
	unlink(tmp2);
	printf("\n\nLED: %s\n\n", GetText("BLD21_MSG"));
	exit(-1);
	break;
  }
}



int getfile(path)
UNSIGNED char path[];
{
  FILE *fp;
  FILE *ff;
  int i = 0;
  UNSIGNED char s[STRING];

  ff = fopen(tmp1, "w");
  if (ff == NULL) {
	printf("\n%s\n", tmp1);
  }
  fp = fopen(path, "r");
  if (fp == NULL) {
	fclose(ff);
	return -1;
  }
  if (fgets(s, STRING, fp) != 0) i++;
  if ((s[0] == 1) && (s[1] == 3)) {	/* MAGIC NUMBER */
	return -2;
  }
  fputs(s, ff);

  while (fgets(s, STRING, fp) != NULL) {
	fputs(s, ff);
	i++;
  }
  fclose(fp);
  fclose(ff);

  return i;
}



main(argc, argv)
int argc;
UNSIGNED char *argv[];
{
  UNSIGNED char s[STRING];

  int eof = 0;


  UMLAUT = 0;
  if (getenv("BBS_USR")==NULL) {
	printf("\nBLED: this editor is only for bbs-usage (not direct)!\n\n", GetText("BLD22_MSG"));
	exit(-1);
  }


  if (argc < 2) {
	printf("\nLED: %s\n\n", GetText("BLD22_MSG"));
	return;
  }

#ifndef _SYS7

  setbuf(stdout, NULL);

#endif

  ansi( "INIT" );

  sprintf(s, " %s ", VERSION);
  headline(s);
 
  printf("\n%s", BLD23_MSG);
  SetMain();
  USER_language=atoi(getenv("BBS_LANG"));
  L_Init();

  sprintf(tmp1, "%s/bled1.%d", TMP, getpid());
  sprintf(tmp2, "%s/bled2.%d", TMP, getpid());

  sprintf(THE_FILE, "%s", argv[1]);
  THE_LINE = 0;

  eof = getfile(THE_FILE);
  printf("%c", CR);
  if (eof == -2) {
	printf("%s \"%s\" %s\n\n", GetText("BLD24_MSG"), THE_FILE, GetText("BLD25_MSG"));
	return;
  }
  if (eof == -1)
	printf("%s", GetText("BLD26_MSG"));
  else
	printf("%s %d %s", GetText("BLD27_MSG"), eof, GetText("BLD28_MSG"));

  signal( SIGINT, SIG_IGN );
  

  printf(" %s: \".?\"\n", GetText("BLD04_MSG"));

  if (eof < 1) eof = 0;
  melted = 0;
  max_line = eof;
  eof++;

  imode = 'A';

  if (erfassen(eof, APPEND) < 1) {
	printf("\n\nLED: %s\n\n", GetText("BLD29_MSG"));
  }
  bledmove(tmp1, THE_FILE);
  unlink(tmp1);
  unlink(tmp2);

  signal( SIGINT, SIG_DFL );

  printf("\n\n%s\n\n", GetText("BLD30_MSG"));
}




/* #YN - Get a char, but only accept GBL06_MSG (Yes, Ja, Qui) and
   GBL07_MSG (No, Nein, Non). */
   
int yesno()
{
     int c;
     
       do {
               c = getint();
                       if (c >= 97) c -= 32;
                               if ((c != GetEChar("GBL06_MSG")) && (c != GetEChar("GBL07_MSG"))) c = 0;
          } while (c == 0);
       printf("%c", c);
             
       return (int) c;
}
                                     
                                     














/* Position eines Strings in einem anderen -> strpos alias PAS */
int strpos(s, t)
unsigned char s[], t[];
{
  int j=0, i = 0, a = 0;


  while (t[i] != 0) {
	j=0;
	if (t[i] == s[0]){
	    a=i+1;
	    while ((s[j]==t[i])&&(s[j]!=0)) {
	       j++; i++;
	     }
	    if (s[j]==0) return (int) a ; else a='0';
	 }
	i++;
  }

  return (int) NULL;
}







unsigned char *punkt2leer(s)
unsigned char s[];
{
  static unsigned char b[STRING];
  int j,k = 0 ;
  
for (j=0;j<=(strlen(s));j++)
{
 b[j]=s[j];
 if (b[j]==46) b[j]=32;
}
 b[j]=0;
  	     
  	     
  return (UNSIGNED char *) (b);
}







unsigned char *cut_arg(s)
unsigned char s[];
{
  static unsigned char arg[STRING];
  int i = 0, a = 0;
  while (s[i] > 32) i++;
  if (s[i] == 0) return (unsigned char *) "";
  while (s[i] == 32) i++;
  while (s[i] != 0) {
	arg[a] = s[i];
	i++;
	a++;
  }
  arg[a] = 0;
  while((arg[(a-1)] < 33) && (a > 1)){
	a--;
	arg[a] = 0;
  }
  return (unsigned char *) arg;
}


unsigned char *cut_bef(s)
unsigned char s[];
{
  static unsigned char bef[STRING];
  int i = 0;


  while (s[i] > 32) {
	bef[i] = s[i];
	i++;
  }
  bef[i] = 0;
  return (unsigned char *) bef;
}




static UNSIGNED char buf[1024];


int ansi(code)			/* for compatibility reasons */
UNSIGNED char code[];
{

#ifdef _PROFILE
  profile( "ansi()" );
#endif

  ansi2(code, 0, 0);
}

int ansi2(code, x, y)
UNSIGNED char code[];
int x, y;
{
  UNSIGNED char *getenv();
  static UNSIGNED char s[STRING];
  UNSIGNED char *p = s;
  UNSIGNED char *term;

#ifdef _PROFILE
  profile( "ansi2()" );
#endif

#ifdef _MBOX
  term = TERMINAL;
#else
  term = getenv("TERM");
#endif

  if ((x == -1) && (y == -1)) {
	if (tgetent(buf, code) != 1) return -1;
  }
  if (strcomp("INIT", code) == 0) {
	if (tgetent(buf, term) != 1) return -1;
  }
  if (strcomp("cm", code) == 0) {
	if (tgetstr(code, &p) == 0) return 1;
	sprintf(s,(UNSIGNED char *) tgoto( s, (x -1), (y -1) ));

        if((s[0] == '2') || (s[0] == '5') ||(s[0] == '3')){ 
            strcpy(s, (UNSIGNED char *) strcopy(s, 1, STRING));
        }	
	printf("%s", s);
	return 0;
  }
  else{
	if (tgetstr(code, &p) == 0) return 1;
  }

  if((s[0] == '2') || (s[0] == '5') ||(s[0] == '3')){ 
            strcpy(s, (UNSIGNED char *) strcopy(s, 1, STRING));
  }
              
  printf("%s", s);

  return 0;
}




/* #HL - Display a text [line] as headline. */

void headline(line)
UNSIGNED char line[];
{
  UNSIGNED char ex[255];
  int i;


  strcpy(ex, line);
  i = 0;
  while(line[i] != '\0'){
	if(line[i] == '^'){
		strcpy(ex, (UNSIGNED char *) strcopy(line, 0, (i-1)));
		line[i] = ' ';
	}
	i++;
  }
  strcpy(headinfo, ex);
  sprintf(ex, "%s                                                                          ", line);
  ex[79] = '\0';
  if (ansi2("cl", 0, 0) != -1) {
	if (ansi2("mr", 0, 0) == 1) {
		if (ansi2("so", 0, 0) == 1) { 
			printf("\n\n------  %s  ------\n\n", line);
			return;
		}
	}
	printf("%s\n", ex);
	if (ansi2("me", 0, 0) == 1) {
		ansi2("se", 0, 0);
	}
  }
  else {
	printf("\n\n\n\n\n------  %s  ------\n\n", line);
  }
}




/* strings-funct */
unsigned char *strings(s)
unsigned char s[];
{
static unsigned char b[STRING];
  int j,k = 0 ;
  
  for (j=0;j<=(strlen(s));j++)
  {
   b[j]=s[j];
    if ((b[j]>127)||(b[j]<32)) b[j]=32;
    }
     b[j]=0;
     
     
return (UNSIGNED char *) (b);
}
       