


#ifndef _ESTDIO
#else
#include <estdio.h>
#endif
#include <sys/types.h>

#ifdef _BSD
#undef _POSIX_SOURCE
#include <sys/stat.h>
#else
#include <sys/stat.h>
#endif


#include <time.h>
#include <dirent.h>
#include <signal.h>

#include <errno.h>

#include <stdio.h>
/*#include <stdlib.h>*/
#include <unistd.h>
#include <strings.h>

#ifndef VU
#include "mbox.h"
#include "s_global.h"
#else
#include "../mbox.h"
#include "../s_global.h"
#endif



#define MAX_CDDRIVES	10




/* #DD - Download files from a CDROM device */

void cd_download( f )
UNSIGNED char f[];
{
  pd( f, f );
  printf("\n");
  ansi2( "mr", 0, 0 );
  printf(" Taste! ");
  ansi2( "me", 0, 0 );
  
  (void) bgetch();
}






/* #CN - Make up a uniq name for every CDROM */

UNSIGNED char *cdname()
{
  FILE *fp;

  DIR *dp;
  struct dirent *actdir;
static  UNSIGNED char s[STRING];
  int i;
  struct stat fst;
  long atime;
 

  strcpy(s, (UNSIGNED char *) ZOPT.OPT->BRETT);
  i = 2;
  while(s[i] != 0){
	if(s[i] == '/'){
		s[i] = 0;
	}
	i++;
  }

  dp = opendir( s );
  if(dp == NULL){
	printf("%s\n",  GetText("CDR05_MSG"));	
	chdir( ZOPT.OPT->HOME );	
	s[0]=0;
	return((unsigned char *) s);
  }
  readdir(dp);
  readdir(dp);
  actdir = readdir(dp);
  strcat(s, (UNSIGNED char *) "/");
  strcat(s, (UNSIGNED char *) actdir->d_name);
  stat(s, &fst);
  atime = (long) fst.st_atime;

  if (atime < 50000000L){
	return (UNSIGNED char *) "0";
  }

  sprintf(s, "%s/cdrom/%ld.dir", ZOPT.OPT->HOME, atime);
  if(mkdir( s, 0777 ) == 0){
	sprintf(s, "%s/cdrom/%ld", ZOPT.OPT->HOME, atime);
	fp = fopen( s, "w" );
	fclose(fp);
  }
  sprintf(s, "%ld", atime);

  return (UNSIGNED char *) s;
}





int buzz;

void busy()
{
  UNSIGNED char s[6];

  strcpy(s, "*|/-\\");

  if(buzz < 1) buzz = 1;
  if(buzz > 4) buzz = 1;

  printf("%c%c%c)", BS, BS, s[buzz]);

  buzz++;
}


/* #CB - Treat a CDROM device like a usual newsgroup */

void cdromB( group, mode )
UNSIGNED char group[];
char mode;
{
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char f[STRING];
  UNSIGNED char n[STRING];
  UNSIGNED char d[STRING];
  UNSIGNED char g[STRING];

  FILE *ff;
  FILE *fp;
  FILE *bbs;

  DIR *dp;
  struct dirent *actdir;
 
  struct stat fst;

  int i, a;
  int OK = 0;
  int IS_DIR = 0;


  if(mode == 'I'){

	if((strcomp(ZOPT.OPT->NG, "cdrom") == 0) || (strcomp(ZOPT.OPT->NG, "cdrom2") == 0)){
		printf("\n");
		ansi2( "us", 0, 0 );
		strcpy(t, (UNSIGNED char *) cdname());
		if(atol(t) < 1L){
			printf("%s <%s> %s\n", GetText("CDR03_MSG"), ZOPT.OPT->NG, GetText("CDR04_MSG"));
			return;
		}
		sprintf(s, "%s/cdrom/%s", ZOPT.OPT->HOME, t);
		show_raw( s, 0 );
		ansi2( "me", 0, 0 );
        }	

	
#ifndef _NOCDINDEX

	i = 0;
	while((ZOPT.OPT->NG[i] != 0) && (ZOPT.OPT->NG[i] != '.')) i++;
	if(i != strlen(ZOPT.OPT->NG)){
		strcpy(s, (UNSIGNED char *) strcopy(ZOPT.OPT->NG, (i + 1), strlen(ZOPT.OPT->NG)));
	}
		else strcpy(s, (UNSIGNED char *) ZOPT.OPT->NG);
	strcpy(t, (UNSIGNED char *) shortname( s ));
	strcpy(f, (UNSIGNED char *) cdname());
	sprintf(s, "%s/cdrom/%s.dir/%s", ZOPT.OPT->HOME, f, t);
	
	fp = fopen( s, "r" );
	if(fp != NULL){
		fclose(fp);
		OK = 0; IS_DIR = 0;
		strcpy(ZOPT.OPT->INHALT, (UNSIGNED char *) s);
		printf("\n");
		goto QUICKIE;
	}

#endif	/* _NOCDINDEX */

	sprintf(d, "%s/%s/CDDIR.%d", ZOPT.OPT->HOME, TMP, getpid());
	fp = fopen(d, "w" );
	if(fp == NULL){
		nerror("cdrom.c", 299, "cdromB", "Can't write to", d);
	}

 	sprintf(s, "%s", (UNSIGNED char *) strcopy(group, 1, strlen(group)));
	i = 0;
	while(s[i] != 0){
		if(s[i] == '/') s[i] = '.';
		i++;
	}
	fprintf(fp, "%s.DIR  30001200  221 y\n", s);

	sprintf(g, "%s/%s/CDJNK.%d", ZOPT.OPT->HOME, TMP, getpid());
	ff = fopen(g, "w" );
	if(ff == NULL){
		nerror("cdrom.c", 305, "cdromB", "Can't write to", g);
	}
	fprintf(ff, "INDEX CDROM (JUNK)\n==================\n");

  	sprintf(t, "%s", group);
	dp = opendir( t );
 	if(dp == NULL){
		printf("%s\n", GetText("CDR05_MSG"));	
		chdir( ZOPT.OPT->HOME );	
		return;
	}

	printf("\n%s ", GetText("CDR09_MSG"));
	ansi2( "md", 0, 0 );
	printf("(*)");
 
	a = 1000;
	readdir(dp);
	readdir(dp);
	while((actdir = readdir(dp)) != NULL){
		sprintf(s, "%s/%s", group, actdir->d_name);

		busy();

		stat(s, &fst);

		if(fst.st_mode & S_IFDIR){
			sprintf(s, "%s.%s", group, actdir->d_name);
			i = 0;
			while(s[i] != 0){
				s[i] = s[i+1];
				if(s[i] == '/') s[i] = '.';
				i++;
			}
			fprintf(fp, "%s  30001200  221 y\n", s);
			IS_DIR++;	
		}
		else{
			strcpy(n, (UNSIGNED char *) actdir->d_name);
			t[0] = 0;
			fprintf(ff, "%-5d %-20.20s  %-43.43s  %ld\n", a, n, t, (int) (fst.st_size / 1024));
			a++;	
		}
	}	
	closedir(dp);
	fclose(fp);
	fclose(ff);

	ansi2( "me", 0, 0 );

	if(IS_DIR) goto DIR_EXIT;

	printf("%c%s ", CR, GetText("CDR10_MSG"));
	ansi2( "md", 0, 0 );
	printf("(*)");

	sprintf(f, "%s/%s/CDIDX.%d", ZOPT.OPT->HOME, TMP, getpid());
	fp = fopen(f, "w" );
	if(fp == NULL){
		nerror("cdrom.c", 367, "cdromB", "Can't write to", f);
	}
	fprintf(fp, "CDROM INDEX\n===========\n");

	sprintf(s, "%s/files.bbs", group);
	bbs = fopen(s, "r" );
	if(bbs == NULL){
		sprintf(s, "%s/00_index.txt", group);
		bbs = fopen(s, "r" );
		if(bbs == NULL){
			sprintf(s, "%s/index", group);
			bbs = fopen(s, "r" );
			if(bbs == NULL){
				sprintf(s, "%s/INDEX", group);
				bbs = fopen(s, "r" );
			}
		}
	}
	if(bbs != NULL){
		a = 1000;
		
		fgets(s, STRING, bbs);
		fgets(s, STRING, bbs);
		if(s[0] >= 'A') rewind(bbs);
	
		while(fgets(s, STRING, bbs) != NULL){

			busy();

			if(s[0] > ' '){
				i = 0;
				while((s[i] != ' ') && (s[i] != TAB) && (s[i] != 0)){
					if((s[i] >= 'A') && (s[i] <= 'Z')) s[i] += 32;
					i++;
				}
				strcpy(n, (UNSIGNED char *) s);
				n[i] = 0;

				sprintf(t, "%s/%s", group, n);
				stat(t, &fst);

				strcpy(t, (UNSIGNED char *) stripped(strcopy(s, i, strlen(s)))); 	
	
				fprintf(fp, "%-5d %-20.20s  %-43.43s  %ld\n", a, n, t, (int) (fst.st_size / 1024));
				a++;
			}
		}
		fclose(bbs);
		OK++;
	}
	fclose(fp);
	
	ansi2( "me", 0, 0 );


	DIR_EXIT:

	if(OK != 0){
		strcpy(ZOPT.OPT->INHALT, (UNSIGNED char *) f);
	}
	else{
		if(IS_DIR != 0)
			ZOPT.OPT->INHALT[0] = 0;
		else
			strcpy(ZOPT.OPT->INHALT, (UNSIGNED char *) g);
	}

	i = 0;
	while((ZOPT.OPT->NG[i] != 0) && (ZOPT.OPT->NG[i] != '.')) i++;
	if(i != strlen(ZOPT.OPT->NG)){
		strcpy(s, (UNSIGNED char *) strcopy(ZOPT.OPT->NG, (i + 1), strlen(ZOPT.OPT->NG)));
	}
		else strcpy(s, (UNSIGNED char *) ZOPT.OPT->NG);
	strcpy(t, (UNSIGNED char *) shortname( s ));
	strcpy(f, (UNSIGNED char *) cdname());
	sprintf(s, "%s/cdrom/%s.dir/%s", ZOPT.OPT->HOME, f, t);


#ifndef _NOCDINDEX

	if((IS_DIR == 0) && (strcomp(t, "cdrom") != 0) && (strcomp(t, "cdrom2") != 0)){
		fp = fopen( ZOPT.OPT->INHALT, "r" );
		ff = fopen( s, "w" );
		if(ff == NULL){
			nerror("cdrom.c", 497, "cdromB", "Can't write to", s);
		}
		while(fgets(s, STRING, fp) != 0){
			fputs(s, ff);
		}
		fclose(ff);
		fclose(fp);
	}

#endif	/* _NOCDINDEX */

/*	QUICKIE:*/

	clearline();
	ansi2( "up", 0, 0 );	
  }			/* End of INDEX Building */


  if(mode == 'L'){	/* Download CDROM Files */

        download_news( group );
  }

  chdir( ZOPT.OPT->HOME ); 
}





#ifdef NOSUPPORT
void cdrom_brett(arg)
UNSIGNED char arg[];
{
  FILE *fp;
  FILE *ff;
  UNSIGNED char s[STRING];
  UNSIGNED char o[STRING];
  int a, h;
  UNSIGNED char t[STRING];
  UNSIGNED char org[STRING];
  UNSIGNED char maybe[STRING];
  int this;
  int i, j;
  int subboard = 0;
  UNSIGNED char c;
  int plus = 0;
  int zeile = 0;
  int toggle = 1;
  int wide = 0; 
  int first = 0;

  if (arg[0] == '!') {
  }
  if ((arg[0] == '+') || (arg[0] == '-')) {
	sscanner(0,arg[0] + 255);
	return;
  }
  if (arg[0] == 0) {
	maybe_locked(UGROUPS, "r");
	fp = fopen(UGROUPS, "r");
	if (fp == NULL) {
		nerror("misc2.c", 242, "brett", "Can't read", UGROUPS);
	}
	arg[0] = '*';
  }
  else {
	if (arg[0] == '^') {
		maybe_locked(NNGROUPS, "r");
		fp = fopen(NNGROUPS, "r");
		if (fp == NULL) {
			nerror("misc2.c", 251, "brett", "Can't read", NNGROUPS);
		}
	}
	else{
		maybe_locked(SGROUPS, "r");
		fp = fopen(SGROUPS, "r");
		if (fp == NULL) {
			nerror("misc2.c", 258, "brett", "Can't read", SGROUPS);
		}
	}
  }
  if((strcomp(CDROMNG, ZOPT.OPT->NG) == 0) && (arg[0] >= 65) && (arg[0] == '~')){
	sprintf(s, "%s/%s/CDDIR.%d", ZOPT.OPT->HOME, TMP, getpid());
	if(fp != NULL) fclose(fp);
	fp = fopen(s, "r");
	if (fp == NULL) {
		nerror("misc2.c", 274, "brett", "Can't read", s);
	}
  }

  strcpy(org, (UNSIGNED char *) arg);

  if (arg[0] == '.') {
	i = 0;
	j = 0;
	strcpy(org, ZOPT.OPT->NG);
	while (org[i] != 0) {
		if (org[i] == '.') j = i;
		i++;
	}
	if (j == 0) return;
	org[j] = 0;
  }
  if (arg[0] == '#') subboard++;

  zeile = 0;

  show(NNGROUPS, 99, 99); /* RESET */

  if ((arg[0] == '*') || (arg[0] == '+') || (arg[0] == '#') || (arg[0] == '~') || (arg[0] == '^')) {

	if(USE_AREAS == 0) 
		if(arg[0] != '^'){
		}
		else{
			sprintf(s, "%s 10) ", GetText("MI205_MSG"));
		}
	else
			sprintf(s, "%s 10, %s \"%s\")", GetText("MI205_MSG"), GetText("MI209_MSG"), AREA);


	headline(s);
	i = 0;
	strcpy(o, (UNSIGNED char *) "OOPS");

	if(ZOPT.OPT->USER.terminal == ISO6429)
		toggle = do_toggle( toggle );


	while (fscanf(fp, "%s %d %d %s", s, &a, &h, t) > 0) {
#ifdef _CNEWS
		if(t[0] == '=') 	
			continue; 
#endif
		
		if((chk_area( s ) != 1) && (arg[0] != '^')) continue;
	

		if (arg[0] == '~') {
			if (strcomp(ZOPT.OPT->NG, s) != 0) continue;
		}
		if ((strcomp(o, s) != 0) || (subboard == 0)) {
			if (subboard != 0) {
				j = subb(s);
				if (j != 0) s[j] = 0;
				o[0] = 0; strcat(o, s);
			}

			if(first == 0){
				first = 1;
				if(strlen(s) > ((STRING/ZOPT.OPT->USER.schluessel[1]) -2)) wide = 1;
			}

			if ((arg[0] == '^') || (arg[0] == '*') || (arg[0] == '~')) {

				if(wide == 0){
					s[((STRING/ZOPT.OPT->USER.schluessel[1]) -2)] = 0;
					strcat(s, "                                   ");
					s[((STRING/ZOPT.OPT->USER.schluessel[1]) -1)] = 0;
					printf("%s", s);
					i++;
					plus++;
				}
				else{
					i = strlen(s);
					while(i < 78){
						s[i] = ' '; i++;
					}
					s[i] = 0;
					printf("%s", s);
					plus++;
					i = ZOPT.OPT->USER.schluessel[1]; 
				}

				if (i == ZOPT.OPT->USER.schluessel[1]) {

					strcpy(s, "                                                                               ");
					s[79 - (i * (STRING/ZOPT.OPT->USER.schluessel[1] -1))] = 0;
					printf("%s", s);

					ansi2( "me", 0, 0 );
					printf("\n");
					i = 0;				
					zeile++;
					if (zeile >= ZOPT.OPT->MAX_SCR_LINES) {
						zeile = 0;
						if(ZOPT.OPT->USER.more != 0){
							if (more() != 0) return (int) 1;
						}
					}
					if(ZOPT.OPT->USER.terminal == ISO6429)
						toggle = do_toggle( toggle );
				}
			}
		}
	}
	if(ZOPT.OPT->USER.terminal == ISO6429){
		if(i != 0){
			strcpy(s, "                                                                               ");
			s[79 - (i * (STRING/ZOPT.OPT->USER.schluessel[1] -1))] = 0;
			printf("%s", s); 
		}
	}

	if (plus == 0) {
		printf("%s", GetText("MI206_MSG"));
	}
	ansi2( "me", 0, 0 );
	printf("\n");
  }
  else {
	if (org[0] != 0) {
		
		while(org[strlen(org) -1] == '.') org[strlen(org) -1] = 0;
	 	do{
			i = sgrep( org, "..");
			if(i != 0){
				strcpy(s, (UNSIGNED char *) org);
				s[i] = 0;
				strcat(s, (UNSIGNED char *) strcopy(org, i+1, strlen(org)));
				strcpy(org, (UNSIGNED char *) s);
			}
		}while(i != 0);	
		
		if(strcomp(CDROM_DUMMY, org) == 0){
			sprintf(s, "cdrom%s", strcopy( org, 14, strlen(org)));
			strcpy(org, (UNSIGNED char *) s);	
		}

		SO_WHAT:

		strcpy(o, (UNSIGNED char *) org);

		i = 0;
		while (org[i] != 0) {
			t[i] = org[i];
			if (t[i] == '.') t[i] = '/';
			i++;
		}
		t[i] = 0;

		if(strcomp(CDROMNG, org) == 0){
			strcpy(s, (UNSIGNED char *) strcopy(org, (strlen(org) -4), strlen(org)));
			if(strcomp(".DIR", s) == 0){

				sprintf(s, "/%s", strcopy(t, 0, (strlen(t) - 5)));
				printf("\n");
				cdromB( s, 'I' );
				 
				strcpy(ZOPT.OPT->BRETT, s);
				sprintf(ZOPT.OPT->NG, "%s", strcopy(org, 0, (strlen(org) -5)));

				sprintf(s, "%s/%s/CDDIR.%d", ZOPT.OPT->HOME, TMP, getpid());		
				unlink( s );

				sprintf(ZOPT.OPT->INHALT, "%s/%s/CDIDX.%d", ZOPT.OPT->HOME, TMP, getpid());
				ff = fopen( ZOPT.OPT->INHALT, "r" );
				if(ff == NULL){
					sprintf(ZOPT.OPT->INHALT, "%s/%s/CDJNK.%d", ZOPT.OPT->HOME, TMP, getpid());
					ff = fopen( ZOPT.OPT->INHALT, "r" );
					if(ff == NULL){
						nerror("misc2.c", 403, "brett", "Can't read", ZOPT.OPT->INHALT);
					}
				}
				fclose(ff);

				return;	
			}
			else{
				sprintf(s, "/%s", t);
			}
 		} 
		else{
			sprintf(s, "%s/%s", NEWS, t);
		}

		if (chdir(s) != 0) {
			sprintf(o, "%s.%s", ZOPT.OPT->NG, org);
			i = 0;
			while (o[i] != 0) {
				t[i] = o[i];
				if (t[i] == '.') t[i] = '/';
				i++;
			}
			t[i] = 0;
			sprintf(s, "%s/%s", NEWS, t);
		}
		if (chdir(s) != 0) {
			this = 9999;
			maybe_locked(NNGROUPS, "r");
			ff = fopen(NNGROUPS, "r");
			if (ff == NULL) {
				nerror("misc2.c", 1001, "brett", "Can't read", NNGROUPS);
			}
			maybe[0] = 0;
			while (fscanf(ff, "%s %d %d %s", s, &i, &i, t) > 0) {
				i = strcomp(org, s);
				if (i < this) {
					this = i;
					strcpy(maybe, s);
				}
			}
			fclose(ff);

			sprintf(s, "%s/%s/CDDIR.%d", ZOPT.OPT->HOME, TMP, getpid());		
			ff = fopen(s, "r");
			if (ff != NULL) {
				sprintf(org, "%s.%s", ZOPT.OPT->NG, arg);
				while (fscanf(ff, "%s %d %d %s", s, &i, &i, t) > 0) {
					i = strcomp(org, s);
					if (i < this) {
						this = i;
						strcpy(maybe, s);
						ZOPT.OPT->INHALT[0] = 0;
					}
				}
				fclose(ff);
			}

			strcpy(org, maybe);
			printf("\n\n");
			ansi2("mr", 0, 0);
			printf("%s \"%s\" [%c, %c] >", GetText("MI207_MSG")
			, maybe, GetEChar("GBL06_MSG"), GetEChar("GBL07_MSG"));
			ansi2("me", 0, 0);
			printf(" ");

			c = yesno();
			
			if (c != GetEChar("GBL07_MSG")) goto SO_WHAT;

			printf("\n");
		}
		else {

			if ((chk_newsgrp(o) == 0) && (chk_adult(o) != -1) &&
			    (chk_sigs(o) != -1)   && (chk_area(o) == 1)) {

				strcpy(ZOPT.OPT->BRETT, s); 
				printf("\n");
				sprintf(ZOPT.OPT->NG, "%s", o);
				if(strlen(o) > 14){
#ifndef _LONGNAMES
					strcpy(o, (UNSIGNED char *) shortname(o));
#endif
				}
#ifdef _NOINDEX
				printf("\n%s ..", GetText("MI211_MSG"));
				switch( (fpid = fork()) ){
					case -1 :
						break;
					case  0 :	while(1){
								printf(".");
								sleep(1);
							}	
						break;
				}
				chdir(ZOPT.OPT->HOME);
				sprintf(s, "%s %s -x", MB_DAEMON, ZOPT.OPT->NG);
				ssystem( s );
				sprintf(s, "mv %s/%s %s/inhalt.%d", LIB, o, TMP, getpid());
				ssystem( s );
				sprintf(ZOPT.OPT->INHALT, "%s/inhalt.%d", TMP, getpid());
				kill( fpid, SIGKILL );
				(void) wait( &fpid );
				printf("\n");				
#else				
				if((strcomp(CDROMNG, org) == 0) || (strcomp(CDROMNG, ZOPT.OPT->NG) == 0))
					cdromB( ZOPT.OPT->BRETT, 'I' );					
				else
					sprintf(ZOPT.OPT->INHALT, "%s/%s", LIB, o);
#endif
				if(strcomp(CDROMNG, ZOPT.OPT->NG) != 0){				
					ansi2( "us", 0, 0 );
					sprintf(s, "%s/.mbox", ZOPT.OPT->BRETT);
					if(prf(s) != -1) printf("\n");
					show_raw( s, 0 );
					ansi2( "me", 0, 0 );
				}
			} else {
				ansi2("md", 0, 0);
				ansi2("me", 0, 0);
			}
		}
		chdir(ZOPT.OPT->HOME);
	}
  }
  fclose(fp);
  ansi2( "me", 0, 0 );
  return;
}

#endif  /* NOSUPPORT */