/*
	Schrodinger's Box Haven  code version -0.1 alpha
        Copyright (C) 1994, Gordon Chan

	You can do whatever ya want with this code as long as you leave this
        copyright & disclaimer intact.  You can hack it up all you want, etc...
        No guarantees.

	Send comments, flames, bug reports, etc ... to
		au233@freenet.carleton.ca  <---- (preferred address for now)
		gjc@achilles.net
		gchan@ccs.carleton.ca
*/


/* Here's the copyrights & disclaimers from the Opium Den and unixCB codes */

/* Opium Den */
/*
  val's haven code v -0.85

        Copyright (C) 1994 Joel Ward

        Warranty:
                Don't blame me for anything.

        You can do whatever the fuck you want with this code as long as you
don't remove this copyright/disclaimer notice.
*/


#include "../config.h"

/* unixCB */
/*
  
  cbd.c
  
  "cbd.c" is the main code for the CB simulator.
  
  Copyright (c) 1992, Gary Grossman.  All rights reserved.
  Send comments and questions to: garyg@soda.berkeley.edu
  
  */

#include<stdio.h>
#include<stdlib.h>
#include<signal.h>

#define MAIN
#include "main.h"
#include "linked_lists.h"

#define STRING 80

#include "defs.h"
#undef HOME
char HOME[STRING];

char LOGINSCREEN[STRING]; /* "/local/tbbs/etc/chat/files/login_screen"*/
char INTRO[STRING];       /* "/local/tbbs/etc/chat/files/intro_screen"*/
char HELP[STRING];        /* "/local/tbbs/etc/chat/files/help" */
char POWER[STRING];       /* "/local/tbbs/etc/chat/files/power" */
char ADMIN[STRING];       /* "/local/tbbs/etc/chat/files/admin" */
char OP_POWER[STRING];    /* "/local/tbbs/etc/chat/files/sysop"*/



/* main forks out process and initilizes the server socket and goes into 
   the main loop */

void main (argv, argc)
	int argv;
	char **argc;
{
	int  childid, sock, port = DEFAULTPORT;	

SetMain();
	if (argv == 2) {
		port = atoi(argc[1]);
		if (!port || port < 1024) {
			printf ("bad port number\n");
			printf ("valid port numbers are >= 1024\n");
			exit (0);
		}			
	}
       setgid(1001);
       setuid(1000);
       setpgrp();
#ifdef DEBUG
	dup2 (2, FD_ERR);
#endif

#ifndef DEBUG
	if (childid = fork() ) {
/*		printf ("port = %d\n", port);
		printf ("child process id = %d\n", childid);
		printf ("parent process is tuning out\n");*/
		printf("\nchatd.. ok\n");
		exit (0);
	}
	close_std();
#endif

	if ((sock = init_socket (port)) == -1)
		return; 

#ifdef DEBUG
	sprintf (err, "server's file descriptor is %d\r\n", sock );
	write_err (err);
	sprintf (err, "server is listening on port %d\r\n", port );
	write_err (err);
#endif

	main_loop (sock);
 
}


void close_std ()
{ 
	close (0);
	close (1);
	close (2);
}

/* signal handlers */

void do_shutdown ()
{
	struct user *u;

	for (u = firstuser; u; u = u->next) {
		if (is_user (u, Ftyping) || is_user (u, Fcomm_line) )
			write_user (u->desc, "\r\n");
		delete_user (u, ">> Shutdown.\r\n", 1);
	}
	exit (0);
}	
		

void signal_handler ()
{

	signal (SIGBUS, SIG_DFL);	
	signal (SIGPIPE, SIG_IGN);
	signal (SIGTERM, do_shutdown);	
	signal (SIGINT,  do_shutdown);	
	
}






char *GRead(entry)
char *entry;
{
FILE *fd;
static char s[2*STRING];

#ifdef BBS_HOME
  sprintf(s,"%s/etc/config/%s",BBS_HOME,entry);
#else
  sprintf(s,"/etc/tbbs.setup/%s",entry);
#endif
  
if ((fd=fopen(s,"r"))!=NULL)
 {
   if (fgets(s,STRING,fd)==NULL)
   printf("\nmain.c, 162, chatd:GRead(); Bad entry in config-base (check the adjustments in \"tbbs.setup\") (%s)\n", entry);
      
   fclose(fd);      
   return((char *) s);   
      
 } else {
  printf("\nmain.c, 168, chatd:GRead(); Bad entry in config-base; Can't read (%s) check the adjustments in \"tbbs.setup\")", s);
  exit(0);
 }
 return(NULL);  
}

/* ++++++++++++++++++++++  Globale CFG lesen ++++++++++++++++++ */
void SetMain()
{
FILE *fd;
unsigned char t[STRING];
char s[STRING],*env;
int i,j;

#ifndef BBS_HOME
	strcpy(HOME,sstrings(GRead("HOME"))); 
#else
	strcpy(HOME,BBS_HOME);
#endif	
	strcpy(LOGINSCREEN,sstrings(GRead("chat.login_sceen")));
	strcpy(INTRO,sstrings(GRead("chat.intro_sceen")));
	strcpy(HELP,sstrings(GRead("chat.help")));
	strcpy(OP_POWER,sstrings(GRead("chat.op_power")));
	strcpy(ADMIN,sstrings(GRead("chat.admin")));
	strcpy(POWER,sstrings(GRead("chat.admin")));
for (i=0; i<STRING; i++)
{
 if ((HOME[i]==32)||(HOME[i]==13)) HOME[i]=0;
 if ((LOGINSCREEN[i]==SPACE)||(LOGINSCREEN[i]==CR)) LOGINSCREEN[i]=0;
 if ((INTRO[i]==SPACE)||(INTRO[i]==CR)) INTRO[i]=0;
 if ((HELP[i]==SPACE)||(HELP[i]==CR)) HELP[i]=0;
 if ((OP_POWER[i]==SPACE)||(OP_POWER[i]==CR)) OP_POWER[i]=0;
 if ((ADMIN[i]==SPACE)||(ADMIN[i]==CR)) ADMIN[i]=0;
 if ((POWER[i]==SPACE)||(POWER[i]==CR)) POWER[i]=0;
}
/*	
printf("\nscreen: %s",ADMIN); 		
printf("\nscreen: %s",OP_POWER); 		
printf("\nscreen: %s",HELP); 		
printf("\nscreen: %s",INTRO); 	
printf("\nscreen: %s",LOGINSCREEN); 	
printf("\nHOME: %s",HOME);	
printf("\nscreen: %s",POWER); 
*/
}



/* strings-funct */
unsigned char *sstrings(s)
unsigned char s[];
{
  static  char b[STRING];
  int j,k = NULL ;
  
for (j=NULL;j<=(strlen(s));j++)
{
 b[j]=s[j];
 if ((b[j]>127)||(b[j]<32)) b[j]=32;
}
 b[j]='\0';
  	     
  	     
  return (char *) (b);
}

