
#include <stdio.h>

#include "defs.h"
#include "config.h"

#define DER01_MSG	"ERROR:"
#define DER02_MSG	"Error:"
#define DER03_MSG	"break"

unsigned char HOME[STRING],BIN[STRING];
char  UUCPID2[STRING],
      ORGANIZATION[STRING],
      LOCATION[STRING];                                


/* #NR - Catching bugs and doing the reporting.

   [file] tells in which file the error occured,
   [line] specifies the code line,
   [function] names the C function,
   [descr] contains a description and
   [er] gives further information. */

void nerror(file, line, function, descr, er)
unsigned char file[];
int line;
unsigned char function[], descr[], er[];
{
  unsigned char s[STRING];

  printf("%c%s %s (%s) - %s \"%s\"\n", CR, DER01_MSG, function, file, descr, er);

  sprintf(s, "[%s] %s, %d\n***** %s, %s, %s ... %s !!!",
	DER02_MSG, file, line, function, descr, er, DER03_MSG);
  
}


void g94()
{
  printf("Just a dummy!");
}



void StrLog(str1)
unsigned char *str1;
{
FILE *fd;
unsigned char s[2*STRING];

 sprintf(s,"%s/etc/errlog/t-bbs.log",HOME);
 if  ((fd=fopen(s,"a"))!=NULL)
 fprintf(fd,"%s",str1);
 fclose(fd);
}




char *GRead(entry)
char *entry;
{
FILE *fd;
static char s[2*STRING];

#ifndef BBS_HOME
 sprintf(s,"/etc/tbbs.setup/%s",entry);
#else
  sprintf(s,"%s/etc/config/%s",BBS_HOME,entry);
#endif
  
if ((fd=fopen(s,"r"))!=NULL)
 {
   if (fgets(s,STRING,fd)==NULL)
nerror("derror.c", 363, "GRead()", "Bad entry in config-base (check the adjustments in \"tbbs.setup\"), start \"tbbs.setup\"-SH-Script", entry);
      
   fclose(fd);      
   return((char *) s);   
      
 } else nerror("derror.c", 367, "GRead()", "Can't read (check the adjustments in \"tbbs.setup\"), start \"tbbs.setup\"-SH-Script", s);
 return(NULL);  
}



/* strings-funct */
unsigned char *sstrings(s)
unsigned char s[];
{
  static unsigned char b[STRING];
  int j,k = 0 ;
  
for (j=0;j<=(strlen(s));j++)
{
 b[j]=s[j];
 if ((b[j]>127)||(b[j]<32)) b[j]=32;
}
 b[j]=0;
  	     
  	     
  return (UNSIGNED char *) (b);
}



/* ++++++++++++++++++++++  Globale CFG lesen ++++++++++++++++++ */
void SetMain()
{
FILE *fd;
unsigned char t[STRING];
char s[STRING],*env;
int i,j;

/*
strcpy(HOME,sstrings(GRead("HOME"))); 
strcpy(BIN,sstrings(GRead("BIN"))); 
*/

/* for Setup: HOME-Check */
strcpy(HOME,

#ifndef BBS_HOME
(char *) sstrings(GRead("HOME"))
#else
 BBS_HOME
#endif

); 


#ifndef BBS_HOME
 strcpy(BIN,(char *) sstrings(GRead("BIN")));
#else
 sprintf(BIN,"%s/bin",BBS_HOME);
#endif


 strcpy(UUCPID2,sstrings(GRead("domain2")));
 strcpy(ORGANIZATION,sstrings(GRead("organisation")));
 strcpy(LOCATION,sstrings(GRead("location")));  


for (i=0; i<STRING; i++)
{
 if ((HOME[i]==SPACE)||(HOME[i]==CR)) HOME[i]=0;
 if ((BIN[i]==SPACE)||(BIN[i]==CR)) BIN[i]=0;
 if ((UUCPID2[i]==SPACE)||(UUCPID2[i]==CR)) UUCPID2[i]=0;
}

/*
printf("\nHOME=(%s)\nBIN=(%s)\nUUCPID2=(%s)\n",HOME,BIN,UUCPID2);
sleep(3);
*/
}



char *GetHome()
{
static char s[STRING];

SetMain();
strcpy(s,HOME);
return((char *) &s);
}