/* ix/MBox configuration file. Read and adjust it VERY well! */
#include "sprache.h"

#ifndef DEF_UQWK
#include "defs.h"
#include "patchlevel.h"
#include "mbox.msg"

#else
#include "s_global.h"
#endif
#include "config.h"

/* The BBS uses two different TMP directories. The first one should be on
   the same drive/partition as the other BBS directories - this will speed
   up copying on systems without symbolic links. The GLOBAL_TMP directory
   should be the unix '/tmp'. */

#define TMP	     	"./tmp"	
#define GLOBAL_TMP	"/tmp"





/* Which newsgroups a new user is allowed to read is said in the
   definition NEWS_MINIMUM. If you want them to get all, enter "all".
   If you like to use all groups in [./etc/active.selected], enter
   "selected". */

#define _NEWS_MINIMUM 	"all"   /*selected"*/
#define _NEWS_LEVEL1	"all"  /*"selected"*/
#define SELECTED	"./etc/active.selected"




/* The place where your systems mailer hides his maildrops should be
   defined in MAILDROP. */

#define MAILDROP	"/usr/spool/mail"



/* If shell users getting their first BBS account, the BBS looks at
   SIGNATURE to use that signature for internal use, too. */

#define SIGNATURE    	".wmailsign"




/* XMD is able to redirect mails to BBS users. Therefore aliases may be
   defined in XMD_ALIAS. Change the file, not the definition! */

#define XMD_ALIAS	"./etc/list.xmd.alias"
#define MAX_XMD_ALIAS   1000



/* This is how XMD recognizes the beginning of an undeliverable mail.
   Look at ERRMBOX (the file, not the definition) after writing a mail
   to "yourdomain!mbox.user" (just variables, use right names instead!). */

#define RETURNED_MAIL   "From postmaster"



/* To calculate the delivering time, XMD looks at TIMEZONES to find out
   where the sender of a mail lives. Your own distance from GMT has to
   be defined in GMT_DIFF. Look at TIMEZONES for the correct value ;-) */

#define TIMEZONES	"./etc/timezones"
#define GMT_DIFF	"+0100" 






/* The INTRO file should include some announcements or messages to 
   users with BBS accounts. */

#define INTRO        	"./etc/intro"



/* In GUESTS_INTRO you may tell your guests some secrets about your BBS
   and how they may become regular users. */

#define GUESTS_INTRO	"./etc/guests.intro"


/* If a user has been thrown out due to a reached timeout or if he/she
   has yet done the max. allowed number of calls, the following file is
   shown. */

#define THROWN_OUT	"./etc/thrown.out"





/* Before showing the BBS name and the "Username:" line, the BBS will
   display the LOGO. Store your ANSI intro or BBS jingle/logo there. */

#define LOGO         	"./etc/logo"




/* DL-UPL-Ratio-File im user-home-pfad */
#define RATIO_FILE	".ratio"          


/* qwk-cfg-file im usr-home-path */
#define QWK_CFG		".qwkrc"












/* Don't change but keep in mind pretty well! The first group of files
   will be update by the BBS. You only should read the files for debug
   reasons. 

   BEFEHLE, HILFE and KURZHILFE will be set up by "make english" (or any
   other language). The prototypes of this files are stored in the
   directory "./src/languages". 

   SEQ, CALLS, ALLTIME and WHO are changed everytime a users calls in. */   


#define SEQ          	"./etc/mbox.seq"
#define CALLS        	"./etc/log.calls"
#define ALLTIME		"./etc/log.alltime"
#define MBSTAT		"./etc/log.stat"
#define WHO          	"./etc/mbox.who"





/* To introduce and describe your's system goodies, use the SYSINFO. */
/* you found the sysinfo-file in ./etc/languages/sysinfo.$$$	
   sysinfo is the name of the sysinfo-file */

#define SYSINFO		"sysinfo"



/* BE VERY CAREFUL HERE! The EDITORS file should contain a list of
   editors which your users can use to enter mails and news articles.

   The first two entries should/MUST be "Led" and "Wendy" to prevent
   seriously security gaps! */

#define EDITORS      	"./etc/list.editors"



#define GAMES	     	"./etc/list.games"
#define MAX_GAMES	9






/* To get the following definitions right, you MUST have a look at 
   the "/etc/passwd" file:
   see for details in ~bbs/INFO/config.runge 
*/  

/* Don't Change!!!!!! */

#define ROOT_UID      	0
#define ROOT_GID      	0
#define GUEST_GID     	1000
#define USERS_GID       GUEST_GID
#define BBSD_UID	GUEST_GID+1
#define GUEST_UID2      GUEST_GID+2
#define GUEST_GID2      GUEST_GID+1
#define BBS_ID		USERS_GID





/* How many terminal ports do you have. Define MAX_TERMINALS correct
   to avoid a wast of memory. -> DUMMY*/

#define MAX_TERMINALS	20









/* There is a news index builder, which should be started every day or
   night after your news system sorted in all new articles. Name the
   place where the binaries of MB_DAEMON are stored (look at Makefile,
   defintion BIN). */

#ifndef MB_DAEMON
#define MB_DAEMON    	"mb-daemon"    /* do not change!!!!  */
#endif


/* The MB_DAEMON will build up a table of the number of incoming articles.
   Don't change the definitions. */

#define MB_DLOG      	"./etc/log.mbd"
#define MB_READY	"./etc/mb.daemon"





/* Now for the Public Domain, Share- or Freeware stuff. The name of
   your PD hierachy/groups is defined as PDNG. PDLOG and PDSCRIPT don't
   need to be changed. Make sure you understood the purpose of PDSCRIPT,
   described in README! */

#define PDNG	     	"local.pd"    		/* -> do not change !!! */
#define PDLOG	     	"./etc/log.pd"
#define PDSCRIPT     	"./etc/pd.script"


/* If you own a CDROM device, you can offer PD stuff and things to your
   very lucky users. I can't imagine any reason to rename the defintions,
   but whatever you do, you have to keep in mind that CDROMNG must never
   be empty - the defintion mustn't be "", that is! */

#define CDROMNG		"cdrom"              /* -> do not change the string "cdrom" */
#define CDROM_DUMMY	"local.pd.cdrom1"     /* -> do not change the string "cdrom" */	



/* die Gruppe, auf die nur 'Erwachsene' zugriff haben duerfen ...*/
#define ADULTNG		"adult"








/* The following REFLECT_LOG needn't be changed. Look at that file from
   time to time, to see who used the reflector. */

#define REFLECT_LOG 	"./etc/log.reflector"



/* I really don't know! It's an offset to get time calculating work
   properly. Maybe I have to set it to '1', cause I'm living at a 
   timezone GMT +0100 ... don't ask, I've no idea! */

#define TZS		1



/* The MIME_VERSION is defined in MIME, METAMAIL or any other RTF-
   package. The BBS doesn't need this, but receivers of you mails
   will! */

#define MIME_VERSION	"1.0"




/* This is for systems only, which are getting the newsgroup "de.etc.finanz",
   where a friendly guy (STOCK_AUTOR) posts business reports. 

   Nobody needs to change anything. Be happy if it works ... */ 

#define STOCK_DJ	"Subject: Dow Jones Aktien"
#define WPKN_DJ		"Subject: Dow Jones Aktien WPKN"
#define STOCK_DAX	"Subject: DAX Aktien"
#define WPKN_DAX	"Subject: DAX Aktien WPKN"
#define STOCK_AUTOR	"Michael_Wagner@the-msu.fido.de"
#define STOCK_PATH	"./stock"
#define STOCK_INDEX	"./stock/index"



/* The following is used only if you are supporting the weather report
   (mis-)feature of the ix/MBox ;-) */

#define WEATHER_REPORT	"./etc/weather.report"


/* The entries for VERSION and AUTOR mustn't be changed by anyone but
   me! */

#define VERSION	     	"t-bbs 1.3"
#define AUTOR_0       	"<runge@boerde.DE> "
#define COPYWRITE      	"1991-1995 ix/MBox BBS 2.8 by <volkers@unnet.wupper.DE>"
#define MBOX_PL		"pl1.8"
#define AUTOR		"<volkers@unnet.wupper.DE>"
#define AUTOR2        	"runge@nina.boerde.DE"
#define QWK_SHELL_VER   "QWK-Shell- v1.1pl18,   (c) runge@nina.boerde.DE"
#define FILEMAN_SHELL_VER   "Filemanager-Shell- v1.0pl8, (c)12/94 <runge@relay.boerde.DE>"
#define BBSMD_VERSION	"T-BBS-Mailer-Daemon v1.1pl6 "
#define PRE_REL		"/pre"


/* To change this isn't part of your duty. Simply ignore it! */

#define X_MAIL_DEMON 	"X-Mail-Daemon"


/* The BBS paths to LIB and AGROUPS may be changed, but there isn't
   any need! */

#define LIB	     	"./lib"
#undef AGROUPS      	/*"./etc/active"*/



/* You don't have to manipulate UDBASE and UDSEQ - neither path nor
   contents! Just keep in mind where both files are and make backups
   fairly often. */

#define UDBASE       	"./etc/users.data"
#define UDSEQ        	"./etc/users.seq"



/* To get the permissions and user id on shell level in order, the BBS
   uses its own shell RSH. Leave this shell where and how it is! */

#define RSH          	"./etc/mbrsh"


/* Some nice (?) IBM-ANSI-Headlines for the PC-DOS callers. No changing
   should be needed. If you like to improve the files you have to use
   an ANSI editor like "TheDraw" (for DOS). */

#define ANSI_COMMANDS		"./etc/ansi/ansi.commands"
#define ANSI_HELP		"./etc/ansi/ansi.help"
#define ANSI_PORTINFO		"./etc/ansi/ansi.who"
#define ANSI_SYSINFO		"ansi.sysinfo" /* please see near SYSINFO-DEF*/
#define ANSI_INTRO		"./etc/ansi/ansi.intro"
#define ANSI_USERS		"./etc/ansi/ansi.users"





/*##########################################################*/
/*  ----QWK ----					    */
/*##########################################################*/
#define QWK_PRINT_FLAG ""    /* "-p"  -DEBUG-MODE*/

#ifdef VGA_GRAFIK
#include "grafik.h"
#endif

/*extern int RIP_ON,RIP_MENUE,ende;*/

#define RIPERRFILE "/tmp/t-bbs.ripscript.error"




/* ACHTUNG: ALLE NACHFOLGENDEN SYSTEM-EINTREAGE WERDEN DURCH 
   DEN KONFIG / CONFIG BEFEHL DER BBS UNGUELTIG !!!!!!!*/   

/* The ORGANIZATION entry will be shown as part of the BBS name and is
   part of your mail & news headers as well. */
#define _ORGANIZATION 	"THE UNDERGROUND NETWORK"



/* The name of your BBS is given by the SYSTEM definition. */
#define _SYSTEM       	"NONAME_BBS"  


/* fuer QWK-Prog.  */
#define QWK_BBS_SYSTEM "noname"   /* System-Name noch mal, jedoch 
				       unbedingt ohne leerzeichen und 
				       in Dos-Format (ohne Ext.) */	
#define QWK_SYSOP  "Sysop"
#define QWK_CITY   "Magdeburg"
#define QWK_BBS_ID "0815,noname"



/* Now for some UUCP/Internet specials. First, define in UUCPSITE how your
   system is called within the networks. */
#define _UUCPSITE     	"nina"



/* If the mailer gets into trouble, it mind find the SMARTHOST entry
   very helpful. */
#define _SMARTHOST	"tumif"



/* If you have a multiuser/multiport chat program, name it in CHAT. */
#define CHAT         	"/usr/bin/chat"


/* There are two different domain names for internal BBS use: UUCPID1 and
   UUCPID2. If you like to make a difference between national and
   international users/account, enter differents domain names here. If
   not, give the same name for both definitions. */
#define _UUCPID2      	"nina.boerde.DE"        
#define _UUCPID1     	"nina.boerde.de"




/* Just to keep old traditions, enter your bang path at UUCPBANG. */ 
#define _UUCPBANG     	"~!Germany.EU.net!csmd!tumif!nina!"


/* If you want your BBS to be the reference system for your area, please
   supply your dial-in number(s) here. */
#define _PHONE		"+49 391 5617702 (Hayes) / +49 391 462114 (HST)"
#define _LOCATION	"Germany (Europe)"



/* To calculate the delivering time, XMD looks at TIMEZONES to find out
   where the sender of a mail lives. Your own distance from GMT has to
   be defined in GMT_DIFF. Look at TIMEZONES for the correct value ;-) */

#define TIMEZONES	"./etc/timezones"
#define GMT_DIFF	"+0100" 



/* Logins and actions of all users are recorded. You have to choose where
   those informations are stored or printed.

   If CONSOLE is defined as "REDIRECT", than the BBS will read the name
   of a file or device in CDIRECTFL and dump the data on that.

   If CONSOLE includes a filename or device, the BBS will user that for
   all log output. */

#define CONSOLE	     	"REDIRECT"
#define CDIRECTFL    	"./etc/mbox.out"



/* All catched errors are recorded in/on CPRN. All not catched errors will
   leave you with a 'core' ;-) */

#define CPRN	     	"t-bbs.errlog"



/* The POSTMASTER is the only person (except "root") who will have complete
   access to the BBS. Enter the name of his/hers shell account! 
   Do not CHANGE - IT IS IMPORTANT INTERNAL FOR BBS !!!!!!!!!!!!!!!
*/

#define POSTMASTER   	"Sysop"


#define CHATPORT 7283      /* Sockets-Port-Nummer fuer Chat- TOOL */


/* wichtig fuer GCC!!!!  */
#undef	__OPTIMIZE__