/**************************************************************************
*	(c) Sylvio Runge, 1/1995					  * 
*	S++ -DEFS fuer T-BBS						  *
***************************************************************************/

/* const */
#define byte	char
/* ++++          Daten-Packet-Typen     +++++   */
#define     pkt_unknown          0x10   /* undefiniert ->Fehlermeldung auf Terminal (Debug-Mode) */
#define     pkt_all              0x01   /* allgemeiner Typ */
#define     pkt_ip               0x02   /* IP-Packet */
#define     pkt_dat              0x03   /* Daten-Packet*/
#define     pkt_ok               0x0a   /* Packet-Bestaetigung */
#define     pkt_get              0x0b   /* Packet-Neu-Anforderung */
#define     pkt_errlog		 0x20	/* Error-Meldungen im User-Log-Terminal*/


/*********** globale Befehle: LEVEL 0 ************/

#define     bef_logoff           0x01   /*quit*/
#define     bef_file             0x02   /*filebase*/
#define     bef_forum            0x03   /*forum*/
#define     bef_who              0x04   /*who*/
#define     bef_spezial          0x05   /*spezial*/
#define     bef_anrufer          0x06   /*anrufer*/
#define     bef_ansage           0x07   /*ansage*/
#define     bef_news             0x08   /*news*/
#define     bef_help             0x09   /*help*/
#define     bef_level            0x0a   /*level*/

#define     bef_upload           0x10   /*upload*/
#define     bef_download         0x11   /*download*/
#define     bef_account          0x12   /*Account*/
#define     bef_version          0x13   /*Version*/
#define     bef_setup            0x14   /*Setup*/
#define     bef_statistik        0x15   /*Statistik*/
#define     bef_status           0x16   /*Status*/
#define     bef_finger           0x17   /*finger*/
#define     bef_user             0x18   /*USER*/
#define     bef_qwk              0x19   /*QWK*/

#define     bef_spionage         0x1a   /*spionage*/
#define     bef_plan             0x1b   /*plan*/
#define     bef_sysinfo          0x1c   /*sysinfo*/
#define     bef_bestellen        0x1d   /*bestellen*/
#define     bef_info             0x1e   /*Info-Base*/
#define     bef_pd               0x1f   /*FileBase*/
#define     bef_talk             0x20   /*Talk*/
#define     bef_df_free          0x21   /*df*/
#define     bef_ps               0x22   /*ps -xa */
#define     bef_usergruppen      0x23   /*usergruppen */
#define     bef_limit            0x24   /*limit */
#define     bef_konto            0x25   /*internet-Konto (DIP) */


/* LEVEL 3 - Object-Befehle  -> noch nicht verwendet (TESTFALL)*/
#define     tobject_t		3x01	/* TObject -Type  */
#define     twindow_t		3x04	/* TWindow  -Type  */
#define     tMDIwindow_t	3x08	/* TMDIWindow  -Type  */


/*++++++++++ der 'globale' Packet-Typ !!!! ++++++++++++*/
    TMsg_Typ = struct
    {
      kennung        : byte;                /* Kennung-zeichen fr s+ :  's'  */
      id             : int;                 /* Packet-ID fr Besttigungen */
      size           : int;                 /* Lnge des Packetes in byte */
      crc            : long;                /* 32-bit-Checksumme fr packet*/
      ptr_next       : int;                 /* Zeiger auf nchstes Packet*/
      pkt_typ        : byte;                /* Packet-Typ: pkt_xxx - constante */
      hwnd           : int;                 /* Windows-Handle */
      count          : long;                /* fortsetungen folgen ..., also erst 'sammeln'*/
      op_start       : int;                 /* zeiger auf weitere Befehls-Daten */
      dat_start      : int;                 /* zeiger auf Daten-Segment */
    };




/*-----------------------------------------------------------------*/
