#include "nntp.h"

#ifdef _LINUX
#define SIGVOID
#endif

#ifdef _BSD
#define _SYS7
#define _SYS_TTYDEV_H_
#include <sgtty.h>   
#include <sys/stat.h>
#endif

#ifndef SIG_T_DEFINED
#ifdef SIGVOID
#  if defined(ultrix)
#   define sig_t void
#  else /* nice compilers: */
    typedef void sig_t;
#  endif
# else

#ifndef _BSD
typedef int sig_t; /* (* sig_t) */
#endif

# endif
#endif /* SIG_T_DEFINED */

#define SHELL_PATH      "/bin/sh"       /* Path of the shell.  */
#define SHELL_NAME      "sh"            /* Name to give it.  */

       


#ifndef  TL_TYP_DEF


#ifdef VU
#define MAX_ARGS  5000
  static char *args[MAX_ARGS];
#endif




/* die Lisa-Defs ;-) */
#define MAX_HISTORY     100

struct lisa_txt_t
{
  char  *txt;
  struct lisa_txt_t *n;
};

struct lisa_msg_t
{
 struct lisa_txt *top;
 struct lisa_msg_t *n;
 int id;
 int anz; 
};

struct lisa_t
{
 char KNOW_HOW[STRING];
 char answer[81][STRING];
 char small_history[(MAX_HISTORY+1)][STRING];
 
 int noa;
 int noo;
 int already;
 int leer, letog;
 int fastmode;
 int debugmode;
 int hacker_alert;
 int sparflamme;
 int lisa_ruhe;
 struct lisa_msg_t *top;

};



struct tree_list_t {
   struct tree_t *entry;
   void *n;
};

struct tree_t {
  struct tree_list_t  *top; 	 /* top der entrys der unterzweige....  */
  struct nrc_ent *np;  		 /* ptr to group-key */ 
  int active;			 /* gruppe ist wirklich existent=1 oder nur virtuell */
  int wahl,scrollto;		 /* User-Postsition in der Gruppen-Liste und Scroller-Pos. */
  char name[40];                 /* name der subgruppe */
  struct tree_t *p; 		 /* vorheriger Hauptzweig (mutter) */
};





#define MAX_ANSWER 20

struct umfrage_t
{
 char rem[LONGSTRING];
 char ans[MAX_ANSWER][STRING];
 int  sum[MAX_ANSWER];
 void *n;
};

struct art_list_t
{
 int art;
 void *n;
};

/* Diskussions-Msg-typ  */
struct dis_t
{
 char dis[STRING];	/* diskusions-Thema */
 char autor[STRING /2]; /* Orginal-Autor */
 void *art;		/* zeiger auf Liste der artikel der disk-runde */
 int org;		/* orginal gefunden */
 int my;		/* ich bin auch dabei ;-) */
 void *n;		/* zeiger auf naechste Diskussions-Runde */
 int art_id;		/* id des Orginal-Artikels */
};


struct act_ent
{
	char *name;		/* Newsgroup name */
	int hi;			/* High article number */
	int lo;			/* Low article number */
	int usr_hi,usr_lo;	 /*Hoechter Artikel-EItrag in USR-LIB*/
	int is_area;		/* gehoert zur Area ? */
	int new,expire; 	/* neue artikel /expire */
	char post;		/* post-Flag aus dem active-file */
	struct act_ent *next,*prev;	/* Pointer to next */
} ;

/* Stuff we remember about the .newsrc file */
struct nrc_ent
{
	char *name;		/* Newsgroup name */
	int subscribed;		/* Subscribed flag */
	int hi;			/* High article number */
	int conf;		/* Corresponding conference number */
	struct nrc_ent *next,*prev;	/* Pointer to next */
} ;

/* ###################################################*/
/* voreingestllte Adresse fuer Postmaster */
#define DEFPOSTMASTER    SF_DEFOWNER



/* Anzeige bei falschen Passwort */

/* max. Anzahl der login - Fehlversuche */
#define ANZ_PW_ERR 6
#define SF_DEFOWNER	"sysop"		/* voreingestellter Eingentuemer von Files ohne INF-Datei */



#define DLUP_RATIO            /* fuehren der DL-UP-Statistik auch im filemanager ;-) */

#define GUEST_LEV 0           /* GUEST-Level ist immer == NULL !!!!!! */
#define ADMIN_LEV 20          /* ADMIN-LEVEL ist immer == 20 !!!! */

/* The following definitions won't need any changes, either. But you
   should have a look at those files. */

#define UDCS		"./etc/list.udc"
#define SFILE_BEFEHLE	"./etc/test.cmd"           /* Bef_test !!!!*/
#define PACKERS		"./etc/list.packers"
#define TERMIS          "./etc/list.terminals"
#define STTOUT		"./etc/list.timeouts"
#define DLUP_RATIO_FILE	   "./etc/list.ratio"


/* Do offer some games. Users will love them - don't ask me why! 
   If you want to have more than 9 games, you have to change the source code! */






#define WHATIS_TXT_POS  63     /* usr-proc-info kommt im w-tool an 62. Position (bei Linux ) */

/* Grundtyp doppelt verkettete Liste */
struct D_TYP {
   unsigned char entry[LONGSTRING];
   struct D_TYP *n,*v ; 
  };




/* verkettete Liste fuer RMail-Statistik (Sysop) */
struct R_TYP {
   char name[STRING];
   long size;
   int mark;
   struct R_TYP *n,*v ; 
  };


struct ngrem_typ {
   char group[40];
   char *rem;
   struct ngrem_typ *n,*v ; 
  };  



/*  doppelt verkettete Liste fuer News-Artikel waehlen */
struct A_TYP {
   unsigned char z[LONGSTRING];
   int on;
   struct D_TYP *n,*v ; 
  };


/* verkettete Liste Gallerie-Bilder */
struct G_TYP {
   unsigned char name[STRING],  /* filename */
   		 info[STRING];  /* kurze Beschreibung */

   long size;
   long time;
   int on,anz;
   struct D_TYP *n,*z ; 
  };

  

struct TL_TYP {
   unsigned char user[LOW_STRING],            /* Name des Auftraggebers */
                 U;			      /* Anfangszeichen */
   int 	         uid,			      /* USER-ID */
                 s_anz,			      /* Anz. der Artikel gesamt */
                 anz,			      /* Anz. Art. / Gruppe */
                 mail,			      /* mail=on */
                 news,		              /* news=on */
                 packer,		      /* packer=zip (==0) */
                 header,		      /* header on/off */
                 pid;			      /* pid bei start (==0 ->fertig*/
   long   time,			              /* zeit der Aufgabe */
          time_ok,		              /* zeit der Erledigung */
          time_cpu;			      /* dauer des Autrages */
   struct TL_TYP *n ;              
};            




/* diverse zusaetzliche Daten-Typen zur allgemeinen bzw. speziellen
   Verwendung */

struct usrproc_typ {
   unsigned char user[STRING/2],	/* user-name bzw. BBS-User-Name*/
   		 tty[STRING/4],		/* tty */
   		 what[STRING],		/* Task */
   		 login[STRING/2],	/* login-Name  */
   		 time[STRING/2],	/* login-Zeit  */
   		 rhost[STRING];         /* R-LOGIN-HOST */
   int 		 bbs,			/* ist bbs-Account */
   		 on,		/* ist markiert */
   		 mute;			/* User will nicht gestoert werden*/		
   struct usrproc_typ *n;
  };



#include <setjmp.h>

#ifndef _BSD
#include  <termio.h>
#else
#include <sys/termios.h>

#endif

/* ++++++++++ assist.c +++++++++ */
#define MAX_ASAR        100


extern int L_INIT;
struct GLOBAL_OPT_TYP {


 int index_on;
 int cdrom_test;



/* ++++++++++ assist.c +++++++++ */
int as_yet_printed;
int asar_ptr;
int as_brett;
int as_plus;
int as_lesen;
int as_inhalt;
int as_setup;
int lisa_ruhe;
int assist_no;
int do_assist;
long CURI_SIZE;
int CURI_NO;
int assist_rd;
unsigned char assist_arg[80];
UNSIGNED char asar[MAX_ASAR][8];

    

/* sfile.c */
int DQUIT;
int QWK_ANZ;  /* Anzahl der QWK-Pakete  im tmp.pfad */
int CD_HOME;
int ENDE;
int AENDERUNG;                      /* BBS-Index-Liste nach Beenden neu oder*/
unsigned char SCRATCH_USER[LOW_STRING]; /* User fuer den das Archiv bestimmt*/
unsigned char w[STRING];                  /* whatis */
int WAIT_FOR_INDEX;                     /* auf index-Daemon warten */
int QWK_NO_BRK;                         /* kein Abbfruch des QWK durch INT */
int INCOMING,
    SCRATCH_PD;
 int no_entry;    
    
    
 /* uudecode.c */
    int noname;
    
   
 /* baudrate.c */  
#ifdef _BSD
  struct termios told;
#else
  struct termio told;
#endif  
 
 
 
 /* QWK - zeug ... */
 int max_art_sum;              /* max.Anzahl der Artikel im QWK-File gesamt,
                                  kann noch vom user nach unten veraendert
                                  werden */
 int max_art;                  /* max.Anzahl der Artikel je Gruppe,
                                  kann noch vom user nach unten veraendert
                                  werden */
 unsigned char sysop[STRING];  /* Sysop-Name fuer QWK */
 unsigned char system[STRING]; /* bbs-name */
 unsigned char city[STRING];   /* stadt-name  */
 unsigned char bbs_id[STRING]; /* BBS-ID */
 int qwk_hidden;	       /* Hintergrund-Mode verboten */	
 int max_qwk_pack;	       /* max. QWK-Pakete, die ein USER aufbewahren 
 				  darf... */
 int qwk_usr_daemon;	       /* QWKD autom. durch USER starten */
 int qwk_blank;			/* alle leeren Gruppen mitnehmen */ 				  
 struct QWK_TYP *qwk;           /* die uebergebenen qwk-Daten (bei Ausfuehrung */
 long maillogsize ;		/* ab welcher Mail-Groesse soll geloggt werden 0==aus */
 int max_bbs_user;		/* max. BBS-User im System */  
 int ende;			/* bbs runterfahren ..... */
 time_t time_start, time_now;   /* startup-Zeit und Ist-Zeit des LOGIN */
 int   SFILEMAN;                /* User im Filemanager */
 int T_ERRMAIL;                 /* USER-LOGIN-MAIL */
 jmp_buf jmpenv;                /* CTRL-JUMP-PUNT */
 int USR_WARNUNG;               /* = 1;*/
 int RELOGIN;                   /*=0; */
 int yet_adult;                 /*=0; */
 int adult_run;                 /*=0; */
 int RIP_ON;
 int RIPMAIL_ON;
 int B_MODE;                    /* ==0 fuer naechste Gruppe
                                  ==1 fuer vorherige  */                                                                      
 int login_pid;                                  
 int NNTP_ON;
 struct usrproc_typ *usrproc_top;
 int GRAFIK_ON; /* VGA-GRAFIK */
 int S_PLUS;		/* S++ Protokoll */
 unsigned int ripio_cmd_chars;  /* Rip_CMD's */
 unsigned char ripcmd[4*STRING];
 int RIP_INIT;
 
 int CONSOLE_ON;
 int RIP_OK;

 int HomePC;
 int IM_SYSOP;
 int NEWLOGIN;
 
 /* mail() */
#ifndef __MBD
 unsigned char ALIASES[STRING];

 unsigned char EDDY_REM[STRING];
 unsigned char HOME[STRING];
 unsigned char BIN[STRING];
#endif
 
 /* AREAS */
 int USE_AREAS; 		/* NetNews in Welten teilen .... */
 int area_fault;
 
#ifndef __MBD
  UNSIGNED char AREA[STRING];
  UNSIGNED char AREACONT[MAX_AREACONT][STRING];
#endif
 
 UNSIGNED char frwd_host[STRING];
 
#ifndef __MBD
  struct userdaten  USER;          /* die Userdaten */
  struct bef_struct BEF[MAX_BEF];  /* die Befehle im Hauptmenue */
  struct bef_struct SBEF[40];      /* die bef. im Filemanager, zur Zeit Dummy */
  struct mak_struct MAK[MAX_MAK];  /* die Makkros */
#endif
 
 int newsgrpptr;
 int MAILOUT_LEV;

 int WRITE_EX_LEV;
 int WRITE_IN_LEV;
 int WRITE_INTERNAT;
 int PD_D_LEV;
 int PD_U_LEV;
 int EXE_LEV;

 
 UNSIGNED char CONSOLE_REDIRECT[STRING];
 
 int BB1;
 int BB2;
 int BB3;
 int BB4;
 int BB5;
 int BB6;
 int BB7;
 int BB8;
 int BB9;
 
 UNSIGNED char UUCPID[STRING];
 
 
 
 int BAUDRATE;
 
 int UMLAUT;
 
 int UMLAUT_MODUS;
 
 int ROT13_MODUS;
 
 int fetch_local;
 UNSIGNED char fetch_subj[STRING];
 
 int DISKUSSION;
 UNSIGNED char DIS_subject[STRING];
 
 int OFFERED_EDITORS;
 
 int TOUT_TIME;
 int TOUT_CALLS;
 UNSIGNED char BEFEHLE[STRING];
 UNSIGNED char HILFE[STRING];
 UNSIGNED char KURZHILFE[STRING];


UNSIGNED char ORGANIZATION[STRING];
UNSIGNED char UUCPSITE[STRING];
UNSIGNED char UUCPID2[STRING];
UNSIGNED char UUCPID1[STRING];
UNSIGNED char NAT_DOMAIN1[STRING];
UNSIGNED char NAT_DOMAIN2[STRING];
UNSIGNED char NAT_DOMAIN3[STRING];
UNSIGNED char UUCPBANG[STRING];
UNSIGNED char PHONE[STRING];
UNSIGNED char LOCATION[STRING];
UNSIGNED char SMARTHOST[STRING];
UNSIGNED char NEWS_MINIMUM[STRING];
UNSIGNED char NEWS_LEVEL1[STRING];
UNSIGNED char PMS_TTY[STRING];
UNSIGNED char UUX[STRING];
UNSIGNED char TAR[STRING];
UNSIGNED char GREP[STRING];
UNSIGNED char SORTEDCUT[STRING];
UNSIGNED char SECONDCUT[STRING];
UNSIGNED char THIRDCUT[STRING];
int TARIF;
int NZNT;
int NZBT;
int RZNT;
int RZBT;
int WZNT;
int WZBT;
UNSIGNED char REFLECT_NG[STRING];


int DOWN_PROT;
int DOWN_PACK;

int G94ACTIVE;

int IP_CAUSED_HUP;

 
int MENUE_USING;
int MENUE_STAGE;
int fido_fast;
int fido_msg; 
 
 
 
 
 int MAX_SCR_LINES;

 int OLDUID;
 int OLDGID;

 UNSIGNED char PROMPT[STRING];
 UNSIGNED char TERMINAL[STRING];

 UNSIGNED char EDDY[STRING];

 UNSIGNED char BRETT[STRING];
 UNSIGNED char INHALT[STRING];
 UNSIGNED char NG[STRING];
 UNSIGNED char MAKRO[STRING];

 UNSIGNED char MYNAME[STRING];
 long LASTLOG;
 int LASTTIME;
 int THISTIME;

 int IS_BUFFERED;

 int SHORT_HEADER;

 long IDX_SIZE;
 int  MBD_SIZE;
 
 /* show.c : Globals for RTF (Richtext Format) */ 
 int tog;
 UNSIGNED char headinfo[STRING];
 int morechen;
 int RTFcomment;
 int RTFcenter;
 int RTFrightflush;
 int RTFheading;
 UNSIGNED char ENCODING[STRING];
 int QPkeys;
 int show_more;
 FILE *page;
 UNSIGNED char show_tmp[STRING];
 int seite;
 
 
 
 /* intro.c */
#ifndef __MBD
 struct RATIO_TYP RATIO ;     /* DL-UPL-Grenzen */
#endif

#ifndef __MBD
 unsigned char SFILE_HLP[STRING];
 struct teca_struct TECA[MAX_TECA];
#endif 
 
 
 
 /* s_qwk2.c */
 FILE *act_fd;
 struct ngrem_typ *ngrem_list; 
 int NEW_NEWSRC;
 
 /* Rip 1.54 */
 int RIP_MENUE;
 unsigned char s[STRING];
 unsigned char title[4*STRING]; 
 
 /*  s_nntp.c */
 
 char last_put[NNTP_STRLEN];
 char nntp_line[NNTP_STRLEN];
 FILE    *nntp_rd_fp;
 FILE    *nntp_wr_fp;
 
 /* chat */
 int chat_socket; 

 /* news-RC */
 struct act_ent *act_list;
 struct nrc_ent *nrc_list;
 
 
 /* Lisa ;-) */
 struct lisa_t lisa ;     /* Lisa-Struct.... */ 
 
 char next_brett[STRING], prev_brett[STRING];
 
 
 /*tty-Terminal - init */
 char tbuf[80];
 int t_init;
 
 unsigned char UUINCOMING[STRING];
 
 
/* show.c - volkers neuer HTML-SRC */ 
 int posit;
 int html;
 int html_ref;
 
 /* adress_book */
 int adr_on;   	/* funktion aktiv ?*/
 int adr_auto;	/* automatic = on ? */
 
 /* demo-Befehl in aktion ?*/
 int demo_mode;
 
 /* for tree- Command */
 struct tree_t *tree_top,	/* zeiger auf Spitze aller Gruppen */
               *tree_cur;	/* aktuelle Position im Baum */  
 struct dis_t *dis;		/* Zeiger auf aktuelle Diskussions-Runde */              
 char dis_gruppe[STRING]; 	/* aktuelle Diskussions-Gruppe  */
 
 
  
  int calls;  /* Anzahl der Anrufe eines Users */
};  /* end OPT_T */




struct VOPT_TYP {

 UNSIGNED char ___DUMMY[STRING];  /* nicht genutzt !!!! */


};





/* Rip-Menues */
#define STARTUP_SCREEN  "cm_hbf\n"	/* Startup-Screen fuer City */
#define NG_MAX_HEADER 30     /* max. Zeilen der NG-Header */

/* der neue News-Support */


/* max. NewsArtikel beim Download: Volker's download*/
#define MAX_DL_FILES 50


#define RIPMAIL_MAXLINES  12

				  
/* qterm-queries */
#define ALTSEND		"\033[c"		/* Alternate query string */
#define WAIT		2			/* Timeout (in seconds) */
#define SIZE		512			/* Receive buffer size */
#define CHAR_MASK	0377			/* Character mask */
/*define ESC		'\033'			 ESCAP  */


#ifndef NCURSES
#ifndef DEP

#ifdef USG5
# define crmode()	(_ntty.c_lflag &= ~ICANON,\
			_ntty.c_cc[VMIN] = 1, _ntty.c_cc[VTIME] = 0,\
			ioctl(_tty_ch, TCSETAF, &_ntty))
# define nocrmode()	(_ntty.c_lflag |= ICANON,\
			_ntty.c_cc[VMIN] = _otty.c_cc[VMIN],\
			_ntty.c_cc[VTIME] = _otty.c_cc[VTIME],\
			ioctl(_tty_ch, TCSETAF, &_ntty))
# define echo()		(_ntty.c_lflag |= ECHO,\
			ioctl(_tty_ch, TCSETAF, &_ntty))
# define noecho()	(_ntty.c_lflag &= ~ECHO,\
			ioctl(_tty_ch, TCSETAF, &_ntty))
#else /* !USG5 */
# define crmode()	(_tty.sg_flags |= CBREAK,\
			ioctl(_tty_ch, TIOCSETP, &_tty))
			
			

# define nocrmode()	(_tty.sg_flags &= ~CBREAK,\
			ioctl(_tty_ch, TIOCSETP, &_tty))


# define echo()		(_tty.sg_flags |= ECHO,	  \
			ioctl(_tty_ch, TIOCSETP, &_tty))
# define noecho()	(_tty.sg_flags &= ~ECHO,  \
			ioctl(_tty_ch, TIOCSETP, &_tty))
#endif /* USG5 */

#endif /* DEP*/



#endif /* NCURSES */




/* TTY-MODES */
#ifndef _BSD
#include <termio.h>
#endif

#ifndef NOTERM
#ifndef _BSD
	static struct termio	told, tnew;
#else	
	static struct sgttyb    told, tnew;
#endif	
#endif

#ifndef _SYS7
#define	get_oldmode()	ioctl(0,TCGETA, &told)
#define	set_oldmode()	ioctl(0,TCSETA, &told)
#define	set_newmode()	(tnew.c_cc[VMIN] = 1,tnew.c_cc[VTIME] = 0,\
			 tnew.c_lflag &= ~(ICANON | ECHO),\
			 ioctl(0, TCSETA, &tnew))
			 
#define	set_newhmode()	(tnew.c_cc[VMIN] = 1,tnew.c_cc[VTIME] = 0,\
			 tnew.c_lflag &= ~ECHO,\
			 ioctl(0, TCSETA, &tnew))			 
			 
/*tnew.c_lflag = (ISIG |  ECHO| ICANON | ECHOCTL | ECHOKE),*/			 
#define	set_new_hidden_mode()	(tnew.c_cc[VMIN] = 1,tnew.c_cc[VTIME] = 0,\
                         tnew.c_oflag=OPOST | ONLCR | \
        ((NLDLY | CRDLY | TABDLY | BSDLY | VTDLY | FFDLY) & tnew.c_oflag), \
			 tnew.c_lflag = ICANON,\
			 ioctl(0, TCSETA, &tnew))			 

#else
static struct sgttyb	told, tnew;

#define	get_oldmode()	ioctl(0,TIOCGETP, &told)
#define	set_oldmode()	ioctl(0,TIOCSETP, &told)
#define	set_newmode()	(tnew.sg_flags |= RAW,tnew.sg_flags &= ~ECHO,\
			 ioctl(0, TIOCSETP, &tnew))

#define	set_newhmode()	(tnew.sg_flags |= RAW,tnew.sg_flags &= ~ECHO,\
			 ioctl(0, TIOCSETP, &tnew))
			 
#define	set_new_hidden_mode() (tnew.sg_flags |= RAW,tnew.sg_flags &= ~ECHO,\
			 ioctl(0, TIOCSETP, &tnew))


#endif   /* ifndef _SYS7 */



struct BBS_OPT_TYP {
  int area_on;
};

struct SPLUS_OPT_TYP {
  int dummy;  
};

struct RIP_OPT_TYP {
  int dummy;  
};



struct nntp_stat_t {
 int auth;
 int posting;
 int ok;
 unsigned char msg[NNTP_STRLEN];
 int stat;
 int article_von,article_bis,article;  
};

struct NEWS_OPT_TYP {
  struct nntp_stat_t nntp_stat;
  int news_mode;  /* 1==nntp  / 2==news_mbd   / 3==news_direct  / 4==mbd-noindex */
  char nntp_port[15];  /* NNTP-Service-name aus der /etc/services */

  int post;
  int nntp_auth;
  int active_local;  /* active-file is local */
  long difftime;   /* zeit in sek. bis bei mode=3 Index neu erstellt wird */
  char nntpserver[STRING];
  int groups,article;  /* Artikel+ Gruppen-Anzahl gesamt aus active-File */
  int newsgroups;
};

struct COLOR_MODE_T {
 unsigned char org[10];
 unsigned char usr[10];
};

struct ANSI_COLOR_TYP {
 struct COLOR_MODE_T mode[25];
}; 


#ifndef __MBD

/* zusaetzliche Option-Struct's fuer S++ etc. */ 
struct ZOPT_TYP  {
  struct ANSI_COLOR_TYP *ansi;
  struct BBS_OPT_TYP 	bbs;
  struct NEWS_OPT_TYP	news;
  struct SPLUS_OPT_TYP  splus;
  struct RIP_OPT_TYP    rip;
  unsigned char tty[30]; /* tty-name */
  struct  GLOBAL_OPT_TYP *OPT;
  struct VOPT_TYP VOPT;
  
  /* NNTP-Timeout-Check */
  int NNTP_TIMEOUT,NNTP_CHECK_ON,GET_NNTP_CHECK_ON;
  int fpid;   /* Parent-PID fuer QWK-Uplopad */

};

extern struct ZOPT_TYP *glb;
extern struct ZOPT_TYP ZOPT;

#endif  /* __MBD */

#define LEER "                                                "

/* MBD -> Gruppen-Statistik */
struct S_GROUP_T {
 int art_anz;
 int art_new;
 int art_exp;
 int gruppen;
};

/* NNTP-Stuff 2*/
#define NUL	'\0'
#define NL 	'\n'

#undef LOGGING   	/* volles Debug-Logging STUFE2  == ON */
#define IRC_TERM	"vt100"    /* terminal-termcap-eintrag fuer IRC */

#define MAX_MUELL_CHAR 6   /* max. moegliche gleiche Zeichen je EIngabefeld, wenn es mehr sind, ist die Eingabe definiert als 'Muell',
                              gueltig fuer Expire+Postfach-Funktion */
                              
                              
                              
#endif /*                #define TL_TYP_DEF                */

#define NO_FILE_INDEX  /* _keine_ BBS-Listen nutzen zur Index-Erzeugung */

/* AutoLogout() */
#define TIME_TICKER 10	 /* Ticker-Zeit in sekunden */
#define TIME_OUT 60*40   /* 40 min Zeit bis autologout */

#define BBS_TASK_PRI 4   /* change process priority for bbs-process */


#define SKEY_DOWN        0402            /* The four arrow keys ... */
#define SKEY_UP          0403
#define SKEY_LEFT        0404
#define SKEY_RIGHT       0405            /* ... */
#define SKEY_HOME        0406            /* Home key (upward+left arrow) */
#define SKEY_END         0550    	/* end key */
#define SKEY_NPAGE       0522            /* Next page */
#define SKEY_PPAGE       0523            /* Previous page */

/* alternatives newsgroup-file (wenn alles ueber nntp kommt) */
#define NEWSGROUPS_KNOWN "./etc/newsgroups"
#define ALIAS_SPOOL "./etc/alias.spool"


/**************************
* For UNIX systems this should be sendmail
* sendmail should be in /usr/lib
*
* You definitely want sendmail, not mail or elm or something else,
* except in the case where MMDF is your mail agent.
* For MMDF you should use submit (SCO)
*/
#ifdef MMDF
#define SYSTEM_MAIL "/usr/mmdf/bin/submit"
#else
#define SYSTEM_MAIL "/usr/lib/sendmail"
#endif /* MMDF */


/* fuer QWK-Reply !!!! */
#define AddFlags  \
  if (!QWK.news) strcat(s," +v "); /* user will keine News */\
  if (a) strcat(s," +n ");  /* News-Permission fuer reply*/\
  if (b) strcat(s," -m +j +m ");  /* Mails-Permission fuer internat. Mails*/ \
    else 						\
    {							\
     if (c) strcat(s," -m +m "); /* nur nationale */	\
    }							
    
#define ANSI_TEST (ZOPT.OPT->USER.schluessel[3] == 128)
  
extern char __LIB_INFO[10];
extern int new_usr;

     
#define ER_DEBUG          		/* no_echo() inaktiv */         
/*#define _USE_SHARED_MEM  		 nutzung von shared-memory wird im makefile automatisch aktiviert*/


#define RIP_SLEEP_LINE  50 /* ms */     /* zeit bis rip-terminal bei schnellen verbindungen 
                                           wieder empfangsbereit ist, -> RIP-Terminal-Bug ! */
                                           
                                            
#define WMNU_QUESTION GetSectionInt("[menu]","wmenu")==1
#define SMNU_QUESTION GetSectionInt("[menu]","smenu")==1
#define F2MNU_QUESTION GetSectionInt("[menu]","fmenu")==1
#define F1MNU_QUESTION GetSectionInt("[menu]","menu")==1



