
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <strings.h>


#include "../mbox.h"
#include "../proto.h"


#include "../s_global.h"
#include "../language.h"


#define LISALOG		

#define LISA_LOG	"/tmp/lisa.log"
#define LISA_DIC	"/tmp/lisa.dic"

#define MY_NAME_IS	"Lisa"		/* Change in "smalltext.c", too !! */




/* #ST - React on users strange inputs [cmdline]. */

int smalltalk_german( cmdline )
UNSIGNED char cmdline[];
{
  UNSIGNED char s[STRING];  
  UNSIGNED char v1[STRING];
  UNSIGNED char v2[31][STRING];
  UNSIGNED char v3[STRING];

  UNSIGNED char question[31][STRING];
  int noq = 0;
  int ok = 0;

  int i = 0, a = 0;  
  int r;

  int val=0;
  int found;
  int ruhe;

  int smv_du, smv_ich, smv_nicht, smv_frage, smv_ja, smv_nein;
  int smv_objekt, smv_person, smv_aktion, smv_blabla;

  FILE *fp;


  sprintf(KNOW_HOW, "./etc/languages/know.%s", LANGUAGE);

  i = ZOPT.OPT->UMLAUT_MODUS;
  ZOPT.OPT->UMLAUT_MODUS = 3;
  strcpy(cmdline, (UNSIGNED char *) iso_line( cmdline ));
  ZOPT.OPT->UMLAUT_MODUS = i;

  ruhe = 0;
  
  smv_du = 0; smv_ich = 0; smv_nicht = 0; smv_frage = 0; smv_ja = 0;
  smv_nein = 0; smv_objekt = 0; smv_person = 0; smv_aktion = 0; smv_blabla = 0;

  if(already != 123)
  {
	strcpy(s, (UNSIGNED char *) mytime( 0 ));
	srand( (int) atoi( (UNSIGNED char *) strcopy(s, 6, 7 ) ));
	already =    123;
	leer =         0;
	fastmode =     0;
	debugmode =    0;
	letog =        9;
	hacker_alert = 0;
	sparflamme =   0;
	lisa_ruhe =    0;

	for(i = 1; i <= MAX_HISTORY; i++){
		strcpy(small_history[i], (UNSIGNED char *) "Lisa Aziz");
	}

#ifdef LISALOG		
		fp = fopen(LISA_LOG, "a" );
		if(fp == NULL)
		{
			nerror("smalltalk.c", 190, "smalltalk", "Can't append to", LISA_LOG);
		} else
		{
			fprintf(fp, "\n+++++++++++ start chat: %s-%s: %s+++++++++++++\n",  ttyna(),ZOPT.OPT->USER.name,cmdline);
			fclose(fp);
		}
#endif		

                                                

  }  

  if(cmdline[0] == '\0'){
	if(hacker_alert){
		if(leer == 0){
			leer++;
			sm_schmoll_d();
			goto DAS_WARS;
		}
		else return(0);
	}
	if(leer == 0) sm_leerzeile_d();
	if(leer == 1) sm_leer1_d();
	if(leer == 2) sm_leer2_d();
	if(leer == 3) letog = (rand() % 30) + 1;
	leer++;
	if((leer > 3) && (leer <= letog)) return(0);
	if(leer > letog){
		leer  = 0;
		letog = 9;
		return(0);
	}
	goto DAS_WARS;
  }

  leer = 0;

  if(hacker_alert > 0) return(0);


  if(strcomp("FASTMODE", cmdline) == 0){
	if(fastmode)
		fastmode = 0;
	else
		fastmode = 1;
  }
  
  if(strcomp("DEBUGMODE", cmdline) == 0){
	if(debugmode){
		debugmode = 0;
		fastmode  = 0;
	}
	else{
		debugmode = 1;
		fastmode  = 1;
	}
  }

  strcat(cmdline, (UNSIGNED char *) " ");

  i = 0; a = 0;

  while(cmdline[i] != '\0'){
	if(cmdline[i] < 'A'){
		noq++;
		strcpy(question[noq], (UNSIGNED char *) strcopy(cmdline, a, (i - 1)));
		a = i + 1;
	}
	i++;
  }
  val = 0; 

  fp = fopen( KNOW_HOW, "r" );
  if(fp == NULL){
	nerror("smalltalk.c", 265, "smalltalk", "Can't read", KNOW_HOW);
  }


  for(i = 1; i <= noq; i++){	/* SM ;-) MAIN-LOOP */

	if(strlen(question[i]) < 2) continue;

	rewind(fp); found = 0;

	while((fgets(s, STRING, fp) != NULL) && (s[0] == '#'));
	while((fgets(s, STRING, fp) != NULL) && (found == 0)){

		if(strlen(s) < 2) continue;

		sscanf(s, "%s %s %s", v1, v2[i], v3);
		
		if(strlen(v1) < 4){
			if((strcomp(v1, question[i]) == 0) &&
			   (strcomp(question[i], v1) == 0)) found++;
		}
		else{
			if(strcomp(v1, question[i]) == 0) found++;
		}
	}

	if(found != 0){

		if(v3[ 0] != '0') smv_du		= i;
		if(v3[ 1] != '0') smv_ich		= i;
		if(v3[ 2] != '0') smv_nicht		= i;
		if(v3[ 3] != '0') smv_frage		= i;
		if(v3[ 4] != '0') smv_ja		= i;
		if(v3[ 5] != '0') smv_nein		= i;
		if(v3[ 6] != '0') smv_objekt		= i;
		if(v3[ 7] != '0') smv_person		= i;
		if(v3[ 8] != '0') smv_aktion		= i;
		if(v3[ 9] != '0') smv_blabla		= i;
	}
	else{
		strcpy(v2[i], (UNSIGNED char *) "Ach wie gut das keiner weiss, ...");
	}

  } 				/* SM ;-) PASS#1 LOOP */

  fclose(fp);


  /* SM PASS#2 LOOP */


  if(smv_frage != 0){		/* FRAGE-Modus */
	
	if(strcomp("WER", 		v2[smv_frage]) == 0){

		if(smv_blabla != 0){
			if(strcomp("DA", 	v2[smv_blabla]) == 0)
				smv_du = smv_blabla;
		}

		if(smv_nicht == 0){
			if(smv_du != 0){
				sm_wer_lisa_d(); ok++;
			}
			if(smv_ich != 0){
				sm_wer_du_d(); ok++;
			}
			if((smv_du == 0) && (smv_ich == 0)){
				sm_wer_d(); ok++;
			}
		}
		else{
			sm_wer_nicht_d(); ok++;
		}
	}

	if(strcomp("WAS", 		v2[smv_frage]) == 0){
		sm_was_d(); ok++;
 	}

	if(strcomp("WELCHE",		v2[smv_frage]) == 0){
		sm_welche_d(); ok++;
 	}

	if(strcomp("WIESO",		v2[smv_frage]) == 0){
		sm_wieso_d(); ok++;
	}

	if(strcomp("WO",		v2[smv_frage]) == 0){
		sm_wo_d(); ok++;
	}

	if(strcomp("WANN", 		v2[smv_frage]) == 0){
		sm_wann_d(); ok++;
	}


	if(strcomp("WIE",		v2[smv_frage]) == 0){
		sm_wie_d(); ok++;
	}

		
	if(strcomp("ZEIT",		v2[smv_blabla]) == 0){
		sm_zeit_d(); ok++;
	}

	if(strcomp("DATUM",		v2[smv_blabla]) == 0){
		sm_datum_d(); ok++;
	}

	if(strcomp("SUCHEN",		v2[smv_blabla]) == 0){
		sm_suchen_d(); ok++;
	}
		
  /*
	smv_du, smv_ich, smv_nicht, smv_frage, smv_ja, smv_nein
	smv_objekt, smv_person, smv_aktion, smv_blabla
  */
	

  }
  else{				/* NORMAL-Modus (KEIN FRAGE-Modus mehr) */

	if(strcomp("DOWNLOAD",		v2[smv_blabla]) == 0){
		sm_pd_d(); ok++;
	}

	if(strcomp("DISKUSSION",	v2[smv_objekt]) == 0){
		sm_dis_d(); ok++;
	}

	if(strcomp("LESEN",		v2[smv_objekt]) == 0){
		sm_befehl_d(); ok++;
 	}

	if(strcomp("ICH",		v2[smv_ich]) == 0){
		sm_ich_d(); ok++;
	}

	if(strcomp("NICHT",		v2[smv_nicht]) == 0){
		sm_nicht_d(); ok++;
	}

	if(strcomp("ALLES",		v2[smv_blabla]) == 0){
		sm_alles_d(); ok++;
	}

	if(strcomp("PROGRAMM",		v2[smv_objekt]) == 0){
		sm_programm_d(); ok++;
	}

	if(strcomp("SYSOP",		v2[smv_person]) == 0){
		sm_syssie_d(); ok++;
	}

	if(strcomp("BITTE",		v2[smv_blabla]) == 0){
		sm_danke_d(); ok++;
	}

	if(strcomp("HALLO",		v2[smv_blabla]) == 0){
		sm_hallo_d(); ok++; lisa_ruhe = 0;
	}

	if(strcomp("SO",		v2[smv_blabla]) == 0){
		sm_so_d(); ok++;
	}

	if(strcomp("ENDE",		v2[smv_blabla]) == 0){
		sm_ende_d(); ok++;
	}

	if(strcomp("STADT",		v2[smv_objekt]) == 0){
		sm_city_d(); ok++;
	}

	if(strcomp("GUT",		v2[smv_blabla]) == 0){
		sm_schoen_d(); ok++;
	}

	if(strcomp("DUMM",		v2[smv_blabla]) == 0){
		sm_bloed_d(); ok++;
	}

	if(strcomp("TANTE",		v2[smv_blabla]) == 0){
		sm_tante_d(); ok++; lisa_ruhe = 0;
	}

	if(strcomp("RICHTIG",		v2[smv_blabla]) == 0){
		sm_richtig_d(); ok++;
	}

	if(strcomp("SHIT",		v2[smv_blabla]) == 0){
		sm_pfui_bah_d(); ok++;
	}

	if(strcomp("DU",		v2[smv_du]) == 0){
		sm_du_d(); ok++;
	}

	if(strcomp("JA",		v2[smv_ja]) == 0){
		sm_ja_d(); ok++;
	}

	if(strcomp("NEIN",		v2[smv_nein]) == 0){
		sm_nein_d(); ok++;
	}

	if(strcomp("LISA",		v2[smv_du]) == 0){
		sm_lisa_d(); ok++; lisa_ruhe = 0;
	}

	if(strcomp("PROBLEM",		v2[smv_blabla]) == 0){
		sm_problem_d(); ok++;
	}

	if(strcomp("MAEDCHEN",		v2[smv_person]) == 0){
		sm_maedchen_d(); ok++;
	}

	if(strcomp("HAHAHA",		v2[smv_blabla]) == 0){
		sm_hahaha_d(); ok++;
	}

	if(strcomp("COMPUTER",		v2[smv_objekt]) == 0){
		sm_computer_d(); ok++;
	}
	
	if(strcomp("OS2",		v2[smv_objekt]) == 0){
		sm_os2_d(); ok++;
	}
	
	if(strcomp("WIN",		v2[smv_objekt]) == 0){
		sm_win_d(); ok++;
	}
	
	
	if(strcomp("BBS",		v2[smv_objekt]) == 0){
		sm_bbs_d(); ok++;
	}

	if(strcomp("FTP",		v2[smv_objekt]) == 0){
		sm_ftp_d(); ok++;
	}	
	
	if(strcomp("RUHE",		v2[smv_blabla]) == 0){
		sm_ruhe_d(); ok++; lisa_ruhe = 1;
		return 0;
	}

	if(strcomp("FRAGEN",		v2[smv_blabla]) == 0){
		sm_fragen_d(); ok++;
	}

	if(strcomp("GELD",		v2[smv_objekt]) == 0){
		sm_geld_d(); ok++;
	}

	if(strcomp("FRECH",		v2[smv_blabla]) == 0){
		sm_frech_d(); ok++;
	}

	if(strcomp("GERN",		v2[smv_blabla]) == 0){
		sm_gern_d(); ok++;
	}

	if(strcomp("WISSEN",		v2[smv_blabla]) == 0){
		sm_wissen_d(); ok++;
	}

	if(strcomp("DAMALS",		v2[smv_blabla]) == 0){
		sm_damals_d(); ok++;
	}

	if(strcomp("WHISKEY",		v2[smv_blabla]) == 0){
		sm_whiskey_d(); ok++;
	}

	if(strcomp("STREIT",		v2[smv_aktion]) == 0){
		sm_streit_d(); ok++;
	}

	if(strcomp("BEFEHL",		v2[smv_blabla]) == 0){
		sm_kommando_d(); ok++;
	}

	if(strcomp("ANTWORT",		v2[smv_blabla]) == 0){
		sm_antwort_d(); ok++;
	}

	if(strcomp("WIRKLICH",		v2[smv_blabla]) == 0){
		sm_wirklich_d(); ok++;
	}

	if(strcomp("HIER",		v2[smv_blabla]) == 0){
		sm_hier_d(); ok++;
	}

	if(strcomp("SUCHEN",		v2[smv_blabla]) == 0){
		sm_suchen_d(); ok++;
	}

	if(strcomp("ENGLISCH",		v2[smv_blabla]) == 0){
		sm_englisch_d(); ok++;
	}
	


	if(strcomp("WIEDERHOL", 	v2[smv_blabla]) == 0){
		sm_wiederhol_d(); ok++;
	}

	if(strcomp("FEHLERFREI",	v2[smv_blabla]) == 0){
		if(fastmode == 0){
			sm_fehlerfrei_d(); ok++;
			fastmode = 1;
		}
		else{
			sm_2fehlerfrei_d(); ok++;
		}
	}
  }

  /* SM PASS#2 LOOP */


  if(ok == 0){
	sm_bug_d();
  }

  DAS_WARS: if(lisa_ruhe) return -1;

  printf("\n\n");

  if(ZOPT.OPT->USER.terminal != ISO6429)
	ansi2( "md", 0, 0 );
  else
	ansi2( "X7", 0, 0 );

  printf("[t-bbs] %s >", MY_NAME_IS);
  ansi2( "me", 0, 0 );
  printf(" ");

  msleep( (rand() % 750) );	/* Thinking ... */

  if(noq < 3) sparflamme++;

  if((sparflamme > 5) && (val < 2)){
	sm_sparflamme_d();
	sparflamme = 0;
  }

  a = 0;

  do{
	r = (rand() % noa) + 1;

	ok = 1;

	for(i = 1; i <= (MAX_HISTORY); i++){
		if(strcomp(answer[r], small_history[i]) == 0) ok = 0;
	}

	a++;
	if(a > 100) ok = 1;	/* Notbremse! */

  }while(ok == 0);

  for(i = 1; i <= (MAX_HISTORY - 1); i++){
	strcpy(small_history[i], (UNSIGNED char *) small_history[i+1]);
  }

  if(a > 100){
	sm_hacker_d();
	r = (rand() % noa) + 1;  
	hacker_alert++;
  }

  strcpy(small_history[MAX_HISTORY], (UNSIGNED char *) answer[r]);

  if(!fastmode){
	scribble( answer[r] );
  }
  else{
	printf("%s", answer[r]);
  }

  printf("\n");
  answer[r][60] = '\0';
  sprintf(s, "[LISA:] %s", answer[r]);
  control( s, 3);
                ZOPT.OPT->assist_no = 0;
                if(ZOPT.OPT->do_assist != 0) assist();
#ifdef LISALOG		
		fp = fopen(LISA_LOG, "a" );
		if(fp == NULL)
		{
			nerror("smalltalk.c", 190, "smalltalk", "Can't append to", LISA_LOG);
		} else
		{
			fprintf(fp, "%s: %s\n    %s\n",  ttyna(),cmdline,s);
			fclose(fp);
		}
#endif		  

  if(debugmode){
	  printf("\n[DEBUG] > Du: %d  Ich: %d  Nicht: %d  Frage: %d  Ja: %d  Nein: %d",
		smv_du, smv_ich, smv_nicht, smv_frage, smv_ja, smv_nein);  
		/*
	  printf("\n\nObjekt: {%s}  Person: {%s}  Aktion: {%s}  BlaBla: {%s}\n",
		question[smv_objekt], question[smv_person], question[smv_aktion],
		question[smv_blabla]);
	  printf("Objekt: {%s}  Person: {%s}  Aktion: {%s}  BlaBla: {%s}\n",
		v2[smv_objekt], v2[smv_person], v2[smv_aktion],
		v2[smv_blabla]);
                */		
  }



  if (ruhe) lisa_ruhe = 1;

  return 0;
}




