

#include <stdio.h>
#include <unistd.h>
#include <strings.h>


#ifndef VU
#include "mbox.h"
#include "s_global.h"
#include "uqwk/uqwk.h"
#else
#include "../mbox.h"
#include "../s_global.h"
#include "../uqwk/uqwk.h"
#endif


/* #IS - Check if users subscribed to a newsgroup [s].

   This function returns 1 if the user has subscribed to the group, or
   0 otherwise. */

int is_subscribed( s )
UNSIGNED char s[];
{
struct nrc_ent *np;
unsigned char t[STRING],tmp[STRING];
 
 np = ZOPT.OPT->nrc_list; 
 sprintf(tmp,"%s:",s);
 sprintf(t,"%s:",np->name);
	while (np != NULL)
	{
	        if (strpos(tmp,t)) return(!np->subscribed) ;
		np = np->next;
		if (np!=NULL)  sprintf(t,"%s:",np->name);
	}

  return (int) 1;
}




/* ueberprueft nur den Sub-String !!*/
int is_ignore_subscribed( s )
UNSIGNED char s[];
{
struct nrc_ent *np;
unsigned char t[STRING],tmp[STRING];
 
 np = ZOPT.OPT->nrc_list; 
 sprintf(tmp,"%s",s);
 sprintf(t,"%s:",np->name);
	while (np != NULL)
	{
	        if (strpos(tmp,t)){
	          if (!np->subscribed) {
	           return (is_subscribed( s ));
	          }
	          return(!np->subscribed) ;
	        }
		np = np->next;
		if (np!=NULL)  sprintf(t,"%s",np->name);
	}

  return (int) 1;
}





/* #GL - compile a "weather report" */

void gloom()
{
  UNSIGNED char wet[17][STRING];
  UNSIGNED char tem[11][STRING];
  UNSIGNED char l[LONGSTRING];
  int c = 0;  /*srand( getpid() ); No comments needed! */
  int hit = (rand() % 15) + 1;
  int temp = (rand() % 10) + 1; 
  int i;
 
  FILE *fp;


 
  strcpy(wet[ 1], (UNSIGNED char *) "it was hot and dry all day");
  strcpy(wet[ 2], (UNSIGNED char *) "it has been sunny and mild");
  strcpy(wet[ 3], (UNSIGNED char *) "is was cloudy with sunny spells");
  strcpy(wet[ 4], (UNSIGNED char *) "the skies have been cloudy");
  strcpy(wet[ 5], (UNSIGNED char *) "the skies were overcast with showers");
  strcpy(wet[ 6], (UNSIGNED char *) "we had hail and thunder");
  strcpy(wet[ 7], (UNSIGNED char *) "we had torrential rain");
  strcpy(wet[ 8], (UNSIGNED char *) "it was stormy and showery");
  strcpy(wet[ 9], (UNSIGNED char *) "it was foggy and misty");
  strcpy(wet[10], (UNSIGNED char *) "it was misty and murky");
  strcpy(wet[11], (UNSIGNED char *) "we had gails and gusts");
  strcpy(wet[12], (UNSIGNED char *) "we had showery rain and snow");
  strcpy(wet[13], (UNSIGNED char *) "it was foggy with showers");
  strcpy(wet[14], (UNSIGNED char *) "we had clouds and high winds");
  strcpy(wet[15], (UNSIGNED char *) "it was freezing cold");
  strcpy(wet[16], (UNSIGNED char *) "it has had blizzard conditions");

  strcpy(tem[ 1], (UNSIGNED char *) "-25 C (-13 F)");
  strcpy(tem[ 2], (UNSIGNED char *) "-10 C (14 F)");
  strcpy(tem[ 3], (UNSIGNED char *) "5 C (41 F)");
  strcpy(tem[ 4], (UNSIGNED char *) "10 C (50 F)");
  strcpy(tem[ 5], (UNSIGNED char *) "15 C (60 F)");
  strcpy(tem[ 6], (UNSIGNED char *) "20 C (68 F)");
  strcpy(tem[ 7], (UNSIGNED char *) "25 C (75 F)");
  strcpy(tem[ 8], (UNSIGNED char *) "30 C (86 F)");
  strcpy(tem[ 9], (UNSIGNED char *) "35 C (95 F)");
  strcpy(tem[10], (UNSIGNED char *) "40 C (104 F)");

  do{
	headline( " Weather Report (MET Office) " );

	ansi2( "cm", 1, 6 );

  	for(i = 1; i <= 16; i++){
		printf("%c ... %s\n", (i + 64), wet[i]);
	}

	ansi2( "md", 0, 0 );

	for(i = 1; i <= 10; i++){
		ansi2( "cm", 48, (5 + i) );
		if(i < 3)
			printf("%d ... %s", (i - 1), tem[i]);
		if( i == 3)
			printf("%d ...   %s", (i - 1), tem[i]);
		if( i > 3)
			printf("%d ...  %s", (i - 1), tem[i]);
	}

	ansi2( "me", 0, 0 );

	sprintf(l, "This weather report has been compiled in %s, where %s. %s %s.", 
		    ZOPT.OPT->LOCATION, wet[hit],
		   "Daytime temperatures reached", tem[temp]);

	i = 78;
	while((l[i] != ' ') && (i > 0)) i--;
	l[i] = '\n';


	ansi2( "cm", 1, 3 );
	ansi2( "us", 0, 0 );
	printf("%s", l);
	ansi2( "me", 0, 0 );

	ansi2( "cm", 1, 23 );
	ansi2( "md", 0, 0 );
	printf("[A-P, 0-9] Und? > ");
  	ansi2( "me", 0, 0 );

	c = bgetch();

	if(c >= 97) c -= 32;


	if((c >= 'A') && (c <= 'P')) hit = (c - 64);

	if((c >= '0') && (c <= '9')) temp = (c - 47);
		
  }while((c != CR) && (c != LF));

  ansi2( "cm", 0, 22 ); 

  fp = fopen( WEATHER_REPORT, "w" );
  if(fp == NULL){
	nerror("subscribe.c", 321, "gloom", "Can't open", WEATHER_REPORT);
  }
  fputs("\n------------------------------------------------------------------------------\n", fp); 
  fputs(l, fp);
  fclose(fp);
}



















