
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <sys/stat.h>
/*#include <stdlib.h>*/
#include <strings.h>
/*#include <sys/wait.h>*/


#ifndef VU
#include "mbox.h"
#define NOTERM 
#include "s_global.h"
#include "language.h"
#else
#include "../mbox.h"
#define NOTERM
#include "../s_global.h"
#include "../language.h"
#endif



#define LONG_ 5



/* #PU - Parse articles to uudecode. */

void prep_uu( argument, pos )
UNSIGNED char argument[];
int pos;
{
  UNSIGNED char s[LONG_*STRING];
  UNSIGNED char t[LONG_*STRING];

  UNSIGNED char subj[LONG_*STRING];
  UNSIGNED char part[LONG_*STRING];
  UNSIGNED char sect[LONG_*STRING];
  UNSIGNED char begi[LONG_*STRING];

  UNSIGNED char bild[STRING];

  UNSIGNED char p1[STRING];
  UNSIGNED char p2[STRING];
  UNSIGNED char p3[STRING];


  int num1, num2;

  int i, m, a, b, _loop;

  int have_it = 0;

  int none = 0;

  int from = atoi((char *) strcopy( argument, 0, (pos -1)));
  int to   = atoi((char *) strcopy( argument, (pos +1), strlen(argument)));

  FILE *fp;
  FILE *ff;
  FILE *fa;

  
  ZOPT.OPT->noname = 0;

  if(argument[0] != 0){

  	if((from == 0) && (to == 0)) return;

  	if(to < from){
		i = to; to = from; from = i;
  	}
  }
  else{
	sprintf(t, "%s/usr/%c/%d/.uud", ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id);
	fp = fopen( t, "r" );
	if(fp == NULL){
		from = 1;	
	}
	else{
		fgets(s, STRING, fp);
		from = atoi( s ) +1;
		fclose(fp);

		fp = fopen( ZOPT.OPT->INHALT, "r" );
		if(fp == NULL){
			nerror("uudecode.c", 88, "uu_prep", "Can't read", ZOPT.OPT->INHALT);	
		}
		fgets(s, STRING, fp);
		fgets(s, STRING, fp);
		fgets(s, STRING, fp);
		fclose(fp);
		
		to = atoi( s );

		fp = fopen( t, "w" );
		fprintf(fp, "%d\n", to);
		fclose(fp);
	}

	if(from == (to +1)){
		printf("%s\n", GetText("UUD00dMSG"));
		return;
	}
  }


  sprintf(t, "%s/usr/%c/%d/.uud", ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id);

  fp = fopen( t, "w" );
  fprintf(fp, "%d\n", to);
  fclose(fp);

  printf("\n");

  sprintf(p1, "%s/parsd.%d", TMP, getpid());
  fa = fopen( p1, "w" );

  sprintf(p2, "%s/parse.%d", TMP, getpid());
  ff = fopen(p2, "w" );

  for(_loop = from; _loop <= to; _loop++){
	
	sprintf(s, "%s/%d", ZOPT.OPT->BRETT, _loop );
	fp = fopen(s, "r" );
	if(fp != NULL){
		m = 0;
		subj[0] = 0;
		part[0] = 0;
		begi[0] = 0;
		sect[0] = 0;
		bild[0] = 0;
	
		while((fgets(s, STRING, fp) != NULL) && (m < 3)){
			if(s[0] == 'M') m++;
			if(strcomp("Subject:", s) == 0){
				strcpy(subj, (UNSIGNED char *) stripped( strcopy( s, 9, strlen(s))));	
			}
			if(sgrep( s, "art" ) != 0){
				strcpy(part, (UNSIGNED char *) stripped( s ));
			}
			if((sgrep(s, "EGIN" ) != 0) || (sgrep(s, "egin") != 0)){
				if(strlen(s) < 12){
					fgets(s, STRING, fp);
					strcpy(begi, (UNSIGNED char *) "begin 644 ");
					strcat(begi, (UNSIGNED char *) s);	
				}
				else
					strcpy(begi, (UNSIGNED char *) stripped( s ));	
			}
			if(sgrep(s, "ection" ) != 0){
				strcpy(sect, (UNSIGNED char *) stripped( s ));
			}
		}		
		fclose(fp);

		if(m >= 3){
			printf("\n");
			ansi2( "md", 0, 0 );
			printf("%s", GetText("UUD02_MSG"));
			ansi2( "me", 0, 0 );
			printf("%5d %s\n", _loop, GetText("UUD00aMSG"));
			strcpy(s, (UNSIGNED char *) "                                           ");
			s[strlen((char *) GetText("UUD02_MSG"))] = 0;
			printf(" %s%s\n%s %s\n%s %s\n%s %s\n", s, subj, s, part, s, begi, s, sect);
			fprintf(ff, "%5d %s\n      %s\n      %s\n      %s\n", _loop, subj, part, begi, sect);
	
			num1 = 0; num2 = 0; have_it = 0;

			if(part[0] != 0){
				a = 0;
				i = 0;
				while((a == 0) && (part[i] != 0)){
					if(part[i] == '/') a = i;
					i++;
				}
				num1 = atoi((char *) strcopy(part, (a -2), (a -1)));
				if(num1 == 0)
					num1 = atoi((char *) strcopy(part, (a -1), (a -1)));	
				num2 = atoi((char *) strcopy(part, (a +1), (a +3)));
	
				a = sgrep( part, "Part" ) -1;
				if(a != 0){
					if(part[(a-1)] != ' ') a--;
					i = a -2;
					b = 0;
					while((i > 0) && (b == 0)){
						if(part[i] == ' ') b = i +1;
						i--;
					}
					strcpy(bild, (UNSIGNED char *) strcopy(part, b, (a -2)));
					if(strlen(bild) > 2) have_it++;	
				}	
			}
		
			if((subj[0] != 0) && (have_it == 0)){
				a = 0;
				i = 0;
				while((a == 0) && (subj[i] != 0)){
					if(subj[i] == '/') a = i;
					i++;
				}
				i = atoi((char *) strcopy(subj, (a -2), (a -1)));
				if(i == 0)
					i = atoi((char *) strcopy(subj, (a -1), (a -1)));
				if(i != 0) num1 = i;	
				i = atoi((char *) strcopy(subj, (a +1), (a +3)));
				if(i != 0) num2 = i;	

				a = sgrep( subj, "/" ) -1;
				if(a != 0){
					i = a;
					while((subj[i] != ' ') && (i > 0)) i--;
					while((subj[i] == ' ') && (i > 0)) i--;
					b = i;	
					while((subj[i] != ' ') && (i > 0)) i--;
			
					strcpy(bild, (UNSIGNED char *) strcopy(subj, i, b));		
					if(strlen(bild) > 2) have_it++;	
				}
			}
			
			if(sect[0] != 0){
				a = 0;
				i = 0;
				while((a == 0) && (sect[i] != 0)){
					if(sect[i] == '/') a = i;
					i++;
				}
				i = atoi((char *) strcopy(sect, (a -2), (a -1)));
				if(i == 0)
					i = atoi((char *) strcopy(sect, (a -1), (a -1)));	
				if(i != 0) num1 = i;
				i = atoi((char *) strcopy(sect, (a +1), (a +3)));
				if(i != 0) num2 = i;	

				a = sgrep(sect, "file") -1;
				if(a != 0){
					b = 0;
					i = a + 5;
					while((sect[i] != 0) && (b == 0)){
						if(sect[i] == ' ') b = i -1;
						i++;	
					}
					strcpy(bild, (UNSIGNED char *) strcopy(sect, (a +5), b));
				}
			}

			if(bild[0] == 0){
				sprintf(bild, "none-%d.%04d", getpid(), none); 
				none++;
			}	

			sprintf(s, (UNSIGNED char *) "                               ");
			s[strlen((char *) GetText("UUD02_MSG"))] = 0;
			ansi2( "us", 0, 0 );
			printf("%s %s: %d (%d) %s <%s>\n", s, GetText("UUD00bMSG"), num1, num2, GetText("UUD00cMSG"), (UNSIGNED char *) stripped(bild));
			ansi2( "me", 0, 0 );
	
			fprintf(ff, "      Guess: %d (%d) of <%s>\n\n", num1, num2, bild);
			fprintf(fa, "%-30s%5d%5d%10d\n", (UNSIGNED char *) stripped(bild), num1, num2, _loop);
		}
	}
	else{
		fprintf(ff, "%5d: CAN'T OPEN <%s>\n", _loop, s);
	}	

  } 
  fclose(ff); 
  fclose(fa);

  sprintf(p3, "%s/parsrt.%d", TMP, getpid());
  sprintf(s, "sort %s > %s", p1, p3);
  ssystem(s);

  t[0] = 0;
  s[0] = 0;

  fp = fopen( p3, "r" );
  while(fgets(bild, STRING, fp) != NULL){
	if(s[0] != 0){
		if(strcomp(s, bild) != 0){
			uudecode( t );
			sprintf(t, "%s ", (UNSIGNED char *) stripped(strcopy(bild, 40, 50)));
			strcpy(s, (UNSIGNED char *) strcopy(bild, 0, 30));	
			printf("%s\n", s);
		}
		else{
			strcat(t, (UNSIGNED char *) stripped(strcopy(bild, 40, 50)));
			strcat(t, (UNSIGNED char *) " ");
		}
	}
	else{
		sprintf(t, "%s ", (UNSIGNED char *) stripped(strcopy(bild, 40, 50)));
		strcpy(s, (UNSIGNED char *) strcopy(bild, 0, 30));	
		printf("%s\n", s);	
	}
  }

  uudecode( t );

  unlink( p1 );
  unlink( p2 );
  unlink( p3 );

  printf("\n");
}


void uudecode( argument )
UNSIGNED char argument[];
{
int a,b,i;

 if (!strpos("-",argument)) uudecode_multiple( argument );
  else 
 {
  sscanf(argument, "%d - %d",  &a, &b);
  if (a<b) 
  {
   for (i=a; i<b; i++) 
    {
     sprintf( argument,"%d",i);
     uudecode_multiple( argument );
    }
  } else FMsgBox(GetText("UUD15_MSG"));
 }

}




/* #UU - Uudecode one or more article(s). */

void uudecode_multiple( argument )
UNSIGNED char argument[];
{
  FILE *fp;
  FILE *ff;
  
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char tmp[STRING];
  UNSIGNED char old[STRING];
  UNSIGNED char older[STRING];
  UNSIGNED char name[STRING];

  int a = 0, b = 0, x = 0;
  int i;
  int ok = 0;
  int artno = 0, lines = 0;
  int uubegin = 0, uuend = 0;

  struct stat fst;


  headline( GetText("UUD01_MSG") );

  sprintf(tmp, "%s/tmp/%d.UUDECODE", ZOPT.OPT->HOME, getpid());
  
  sprintf(s,"%s/%d",ZOPT.OPT->UUINCOMING,ZOPT.OPT->USER.id);
  mkdir(((char *) s),0777);
                
  	ff = fopen( tmp, "w" );
        if(ff == NULL){
	 nerror("uudecode.c", 44, "uudecode", "Can't write to", tmp);	
	 return;
	}

  a = 0;
  i = 0;
  while(argument[i] != 0){
	if(argument[i] == '-') a = i;
	i++;	
  }   
  if((a != 0) || (argument[0] == 0)){
	prep_uu( argument, a );
	return;
  }
 

  strcat(argument, " ");


  
  while(argument[x] != 0){
	if(argument[x] == ' '){
		b = x - 1;
		strcpy(s, (UNSIGNED char *) bigcopy(argument, a, b));
		if(atoi(s) != 0){

			if (strcomp(ZOPT.OPT->BRETT, "PM") != 0) {
				sprintf(t, "%s/%s", ZOPT.OPT->BRETT, s);
			}
			else {
				sprintf(t, "%s/usr/%c/%d/%s", ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id, s);
			}
			
			fp = fopen( t, "r" );
			if(fp == NULL){
				goto NOT_FOUND;
			}
			ansi2("md", 0, 0);
			printf("\n%s", GetText("UUD02_MSG"));
			ansi2("me", 0, 0);
			printf(" %s", s);
			artno++;
			lines = 0;
  ansi("us");
  printf("\n%s\n",(char *) GetText("BLD23_MSG"));
  ansi("me");
			while(fgets(s, STRING, fp) != NULL){
					if(strcomp("Subject:", s) == 0){
						i = 0;
						while(s[i] != 0){
							if(s[i] == '/'){
								strcpy(t, (UNSIGNED char *) strcopy(s, (i-2), (i-1)));
								if((atoi(t) != artno) && (atoi(t) != 0)){
									ansi2("md", 0, 0);
									printf("  %s (%d %s %d)", GetText("UUD03_MSG"), atoi(t), GetText("UUD04_MSG"), artno);
									ansi2("me", 0, 0);
								}
							}
							i++;
						}						
					}
					if((strcomp("begin", s) == 0) && (s[0] == 'b') && (strcomp("begin part ", s) != 0)){
						ok++;
						uubegin = 1;
						strcpy(name, (UNSIGNED char *) stripped( (UNSIGNED char *) strcopy(s, 10, 80)));
						printf("  [%s]", (UNSIGNED char *) name);
					} 
					if((strcomp("end",   s) == 0) && (s[0] == 'e')){
						ok++;
						uuend = 1;
						fputs(older, ff);
						fputs(old, ff);
 					}
					if((s[0] == 'M') && ((strlen(s) == 62) || (strlen(s) == 63))){
						ok++;
					}
			
					if(ok != 0){
						fputs(s, ff);
						lines++;
					}
					ok = 0;
			
					strcpy(older, (UNSIGNED char *) old);				
					strcpy(old, (UNSIGNED char *) s);			
			}			
			fclose(fp);
		}
		a = x + 1;
	}
	NOT_FOUND:
	x++;
  }

  fflush( ff );
  fclose( ff );

  printf("\n\n");

  if(strlen(name) < 2){
	sprintf(name, "noname.%d", ZOPT.OPT->noname);
 	ZOPT.OPT->noname++; 
  }

  if (uubegin == 0) {
	unlink( tmp );
	printf("%s\n", GetText("UUD05_MSG"));
	return;
  }
  if (uuend == 0) {
	unlink( tmp );
	printf("%s\n", GetText("UUD06_MSG"));
	return;
  }

  sprintf(s,"%s/%d",ZOPT.OPT->UUINCOMING,ZOPT.OPT->USER.id);
  chdir( ((char *) s) );
  sprintf(s, "%s %s", UUDECODE, tmp);
  
  ssystem( s );
  chdir( ZOPT.OPT->HOME );


  sprintf(s, "%s/%d/%s", ZOPT.OPT->UUINCOMING,ZOPT.OPT->USER.id, name);
  stat(s, &fst);
  if(fst.st_size == 0){
	printf("%s\n", GetText("UUD06aMSG"));
	return;
  }
 
  sprintf(s, "%s/usr/%c/%d/.lastletter", ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id);
  fp = fopen(s, "w");
  fprintf(fp, "BINFILE\n");
  fprintf(fp, "%s/%d/%s\n", ZOPT.OPT->UUINCOMING,ZOPT.OPT->USER.id, name);
  fclose(fp);

  sprintf(s, "%s/usr/%c/%d/.lastsubject", ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id);
  fp = fopen( s, "w" );
  fprintf(fp, "Decoded %s", name);
  fclose(fp);

  ZOPT.OPT->IS_BUFFERED = 1;

  sprintf(s, "%s$", ZOPT.OPT->USER.name);
  brief( s );

  printf("%s %s (%ld %s)\n", GetText("UUD07_MSG"), name, fst.st_size, GetText("UUD08_MSG"));

  ZOPT.OPT->IS_BUFFERED = 0;
}



/* #DR - Print a mail or an article. */

void drucken( argument )
UNSIGNED char argument[];
{
  UNSIGNED char s[STRING];
 
  if (ZOPT.OPT->USER.level < ADMIN_LEV) {
	return;
  }

  if (strcomp(ZOPT.OPT->BRETT, "PM") != 0) {
	sprintf(s, "%s %s/%s", PRINTER, ZOPT.OPT->BRETT, argument);
  }
  else {
	sprintf(s, "%s %s/usr/%c/%d/%s", PRINTER, ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id, argument);
  }

  ssystem(s);
}


/* #PW - Preview a (gif-) picture */

void preview( argument )
UNSIGNED char argument[];
{
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];

  FILE *fp;


  if (strcomp(ZOPT.OPT->BRETT, "PM") != 0) {
	sprintf(s, "%s/%s", ZOPT.OPT->BRETT, argument);
  }
  else {
	sprintf(s, "%s/usr/%c/%d/%s", ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id, argument);
  }

  t[0] = 0;

  fp = fopen( s, "r" );
  if(fp == NULL){
	ansi2( "md", 0, 0 );
	printf("%s", GetText("UUD01aMSG"));
	ansi2( "me", 0, 0 );
	return;
  }
  while(fgets(s, STRING, fp) != NULL){
	if(strcomp("BINFILE", s) == 0){
		fgets(s, STRING, fp);
		sprintf(t, "%s %s", PREVIEW, (UNSIGNED char *) stripped(s));
	}
  }
  fclose(fp);

  if(t[0] == 0){
	return;
  }
  else{
	printf("\n\n");
	ssystem( t );
  }
}



/* #MD - Check whether a newsgroups is moderated  

   This functions returns 1 if the newsgroups has a moderator. */

int moderated( argument )
UNSIGNED char argument[];
{

  return 0;
}


/* #SV - Screen saving mode */

void saver()
{
  UNSIGNED char s[STRING];
  int a[5][30];
  int i, p;
  int fpid;
  int c;
  int n = 0;
  int first_choice;
  int b1, b2, b3, b4, b5;


  first_choice = (rand() % 3) + 1;




  strcpy(s, (UNSIGNED char *) mytime( 0 ));
  srand( (int) atoi( (UNSIGNED char *) strcopy(s, 6, 7 ) ));

  
  for(i = 1; i < 29; i++){
	a[1][i] = (rand() % 78) +  1;
	a[2][i] = (rand() % 24) +  1;
	a[3][i] = (rand() %  7) +  1;
	a[4][i] = (rand() %  4) +  1;
  }
  
  /*
  switch( (fpid = fork()) ){
	case -1 :
		return;	
		break;
	case  0 : 
   */
#ifndef _ESTDIO
		nice( 15 );
#endif
		if(ZOPT.OPT->USER.schluessel[3] == 128){ /* MS-DOS Charset */	
			b1 = 219; b2 = 250; b3 = 249; b4 = 254; b5 = 220;
		}
		else{				/* Other Charsets (i.e. LINUX) */
			b1 =  32; b2 =  46; b3 =  46; b4 =  46; b5 = 164;
		}

		if(first_choice == 3){

			a[1][1] = 40;
			a[1][2] = 13;
			a[1][3] = 1;

			while(!kb_pressed()){
				p = rand() % 20 + 1;
				n = rand() % 4 + 1;
			
				for(i = 0; i <= p; i++){

					do{
						switch(n){
							case 1 : a[1][1]--;
								 break;
							case 2 : a[1][1]++;
								 break;
							case 3 : a[1][2]--;
								 break;
							case 4 : a[1][2]++;
								 break;
						}

						if ((a[1][1] < 1) || (a[1][1] > 79) ||
						    (a[1][2] < 1) || (a[1][2] > 24)){
							n++;
							if(n > 4) n = 1;	
							a[1][3]++;
							if(a[1][3] > 7) a[1][3] = 1;
						}
					}while((a[1][1] < 1) || (a[1][1] > 79) ||
					       (a[1][2] < 1) || (a[1][2] > 24));

					ansi2( "cm", a[1][1], a[1][2] );
					printf("%c[30;%dm", ESC, 40 + a[1][3]);
					printf("  ");
					ansi2( "cm", 1, 24 );				
					printf("%c[0m%c[30;40m%c%c", ESC, ESC, 32, 8);
					msleep( 200 );	
				}	
			}
		}

		if(first_choice == 1){

			ansi2( "cl", 0, 0 );
	
			while(!kb_pressed()){

				for(i = 19; i > 1; i--){
					
					if(a[4][i] < 3){
						printf("%c[%dm", ESC, 30 + a[3][i]);
					}
					else{
						if(a[4][i] < 5){
							printf("%c[1;%dm", ESC, 30 + a[3][i]);
						}
						else	
							printf("%c[%dm", ESC, 30);
					}	

					ansi2( "cm", a[1][i], a[2][i]);

					switch(a[4][i]){
						case 1 : printf("%c", b2);
							 break;
						case 2 : printf("%c", b3);
							 break;
						case 3 : printf("%c", b3);
							 break;
						default: printf(" ");
							 break;
					}		
					printf("%c[0m%c[30;40m%c%c", ESC, ESC, b1, 8);

					a[4][i] += 1;
					
					if(a[4][i] > 5){
						a[1][i] = (rand() % 78) + 1;
						a[2][i] = (rand() % 24) + 1;
						a[3][i] = (rand() %  7) + 1;
						a[4][i] = 1;
					}
				}
				msleep( 150 );
			}
		} else
			
		if(first_choice == 2){

			ansi( "cl", 0, 0 );

			while(1){

				for(i = 29; i > 1; i--){		

					ansi2( "cm", a[1][i], a[2][i]);
					printf("  ");	
					
					printf("%c[0m%c[30;40m%c%c", ESC, ESC, b1, 8);

					if(a[1][i] < 40){
						a[1][i] -= rand() % 3 + 1;
						if(a[1][i] < 1){
							a[1][i] = (rand() % 5) + 37;
							a[3][i] = (rand() % 15) +  1;	
						}
					}			
					else{
						a[1][i] += rand() % 3 + 1;
						if(a[1][i] > 78){
							a[1][i] = (rand() % 5) + 37;
							a[3][i] = (rand() % 15) +  1;
						}
					}	

					if(a[2][i] < 13){
						a[2][i] -= rand() % 3 + 1;
						if(a[2][i] < 1){
							a[2][i] = (rand() % 3) + 12;
							a[3][i] = (rand() % 15) +  1;
						}
					}
					else{
						a[2][i] += rand() % 3 + 1;
						if(a[2][i] > 25){
							a[2][i] = (rand() % 3) + 12;
							a[3][i] = (rand() % 15) +  1;		
						}
					}
			
					p = a[3][i];
					if(p > 8)
						printf("%c[1;%dm", ESC, 30 + a[3][i] - 8);
					else
						printf("%c[%dm", ESC, 30 + a[3][i]);

					ansi2( "cm", a[1][i], a[2][i]);
	

					if(((a[1][i] > 20) && (a[1][i] < 60)) &&
					   ((a[2][i] > 8) && (a[2][i] < 18))){
						printf("%c", b4);
					}
					else{
						if(((a[1][i] > 10) && (a[1][i] < 70)) &&
						   ((a[2][i] > 4) && (a[2][i] < 22))){
							printf("%c", b5);
						}
						else{
							if(p > 8)
								printf("%c[1;%dm", ESC, 40 + a[3][i] - 8);
							else
								printf("%c[%dm", ESC, 40 + a[3][i]);
							printf("%c%c", b1, b1);
						}
					}				
					printf("%c[0m%c[30;40m%c%c", ESC, ESC, b1, 8);
				}
				msleep( 200 );
			}
		}
/*		
  }

  c = getint();
  c = getint();

  kill( fpid, SIGKILL );
  (void) wait( &fpid );		
*/
  if(ZOPT.OPT->USER.schluessel[2] == INTEL_INSIDE) 	
	printf("%c[37;40m %c", ESC, BS);

  ansi2( "me", 0, 0 );
  ansi2( "cm", 1, 1 );

  for(i = 0; i < 25; i++){
	ansi2( "al", 0, 0 );
	msleep( 10 );
  }

  headblock( GetText("LOP14_MSG"), GetText("LOP15_MSG") );
  show(CALLS, 19, ZOPT.OPT->USER.more);

  return;  
} 





/* #CA - Make sure only adults can enter certain newsgroups
         This function returns -1 if users are NOT allowed to
         enter a group. */

int chk_adult( o )
UNSIGNED char o[];
{
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char r[5];
 
  int ok = 1, i, j, a, b, c, l;

  int maxq, cora=0, fehler = 0; 

  FILE *fp;

  
  if(strcomp(ADULTNG, o) != 0) return (int) 1;
  if(ZOPT.OPT->yet_adult != 0) return (int) 1;

  sprintf(t, "%s/src/languages/%s.adt", ZOPT.OPT->HOME, LANGUAGE);
  fp = fopen( t, "r" );
  if(fp == NULL){
	nerror("uudecode.c", 1101, "chk_adult", "Can't read", t);	
  }

  ZOPT.OPT->adult_run++;

  if(ZOPT.OPT->adult_run > 3){
	ansi2( "md", 0, 0 );
	printf("\n\n\nZugriff verweigert! Pro Anruf duerfen nur drei Versuche unternommen\n");
	printf("werden, um in dieses Brett zu kommen!\n\n");
	ansi2( "me", 0, 0 );
	printf("Das Brett [%s] ist nix fuer Kinder!");
	return (int) -1;
  }
  
  ansi2( "md", 0, 0 );
  printf("\n\n\nZugriff nur fuer Erwachsene! Bitte beantworten Sie die drei nun folgenden\n");
  printf("Fragen korrekt, um Ihre Qualifikation zu beweisen!\n\n");
  ansi2( "me", 0, 0 ); 

  i = 0;
  strcpy(t, (UNSIGNED char *) "000");

  do{ 
	i++;
	rewind(fp);
	fgets(s, STRING, fp);
	maxq = atoi(s) -1;
	if(maxq == 0){
		nerror("uudecode.c", 1111, "chk_adult", "No answers in", t);	
	}

	do{	
 		a = (rand() % maxq);
	}while((a == r[0]) || (a == r[1]));

	b = 0; r[(i-1)] = a;

	while(b < a){
		fgets(s, STRING, fp);
		if(strlen(s) < 3) b++;
	}

  	fgets(s, STRING, fp);
	printf("%s\n");
	
	for(j = 1; j < 5; j++){
		fgets(s, STRING, fp);
		l = strlen(s) -2;
		if(s[l] == '*'){
			s[l] = ' ';
			cora = j + 48;
		}
		printf("%d  -  %s", j, s);
	}

	ansi2( "md", 0, 0 );
	printf("\nWie lautet die korrekte Antwort? ");
	ansi2( "me", 0, 0 );

	do{
		c = getch();
	}while((c < '1') || (c > '4'));

	if(c == cora){
		printf("%c ist korrekt!\n\n", c);
	}
	else{
		printf("%c ist falsch!\n\n", c);
		fehler++;
		if(fehler > 1)
			ok = -1;
		else
			i--;
	}
  }while((i < 3) && (ok == 1));

  if(ok == -1){
	printf("Das Brett [%s] ist nix fuer Kinder!");
	sprintf(s, (UNSIGNED char *) "<ADULT> No Access! (%d)", i);	
	strcpy(ZOPT.OPT->BRETT, (UNSIGNED char *) "PM");
	sprintf(ZOPT.OPT->NG, "%s.PM", ZOPT.OPT->USER.name);
	sprintf(ZOPT.OPT->INHALT, "%s/usr/%c/%d/INDEX", ZOPT.OPT->HOME, ZOPT.OPT->USER.name[0], ZOPT.OPT->USER.id);
  }
  else{
	printf("Alles klar. Zugriff gestattet ...\n");
	sprintf(s, (UNSIGNED char *) "<ADULT> Alright!");
	ZOPT.OPT->yet_adult++;
  }
  control( s, 3 );

  fclose(fp);

  return (int) ok;
}


/* #MM - Take seconds an make up a time output readable by humans.
*/

UNSIGNED char *make_time( seconds )
int seconds;
{
  static UNSIGNED char s[STRING];

  int hour, min, secs;

  hour = seconds / 3600;
  min  = (seconds - (hour * 3600)) / 60;
  secs = seconds - (hour * 3600) - (min * 60);

  sprintf(s, "%02d:%02d:%02d", hour, min, secs);

  return (UNSIGNED char *) s; 
}
